import type { CancelablePromise } from "../core/CancelablePromise.js";
import type { BaseHttpRequest } from "../core/BaseHttpRequest.js";
export declare class AccessTokensService {
    readonly httpRequest: BaseHttpRequest;
    constructor(httpRequest: BaseHttpRequest);
    /**
     * Get all access tokens
     * Get all access tokens
     * @returns any Default Response
     * @throws ApiError
     */
    getAll(): CancelablePromise<{
        result: Array<{
            id: string;
            tokenMask: string;
            walletAddress: string;
            createdAt: string;
            expiresAt: string;
            label: (string | null);
        }>;
    }>;
    /**
     * Create a new access token
     * Create a new access token
     * @param requestBody
     * @returns any Default Response
     * @throws ApiError
     */
    create(requestBody?: {
        label?: string;
    }): CancelablePromise<{
        result: {
            id: string;
            tokenMask: string;
            walletAddress: string;
            createdAt: string;
            expiresAt: string;
            label: (string | null);
            accessToken: string;
        };
    }>;
    /**
     * Revoke an access token
     * Revoke an access token
     * @param requestBody
     * @returns any Default Response
     * @throws ApiError
     */
    revoke(requestBody: {
        id: string;
    }): CancelablePromise<{
        result: {
            success: boolean;
        };
    }>;
}
