'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

/* generated using openapi-typescript-codegen -- do no edit */
/* istanbul ignore file */
/* tslint:disable */
/* eslint-disable */

class BaseHttpRequest {
  constructor(config) {
    this.config = config;
  }
}

/* generated using openapi-typescript-codegen -- do no edit */
/* istanbul ignore file */
/* tslint:disable */
/* eslint-disable */

class ApiError extends Error {
  constructor(request, response, message) {
    super(message);
    this.name = 'ApiError';
    this.url = response.url;
    this.status = response.status;
    this.statusText = response.statusText;
    this.body = response.body;
    this.request = request;
  }
}

/* generated using openapi-typescript-codegen -- do no edit */
/* istanbul ignore file */
/* tslint:disable */
/* eslint-disable */
class CancelError extends Error {
  constructor(message) {
    super(message);
    this.name = 'CancelError';
  }
  get isCancelled() {
    return true;
  }
}
class CancelablePromise {
  #isResolved;
  #isRejected;
  #isCancelled;
  #cancelHandlers;
  #promise;
  #resolve;
  #reject;
  constructor(executor) {
    this.#isResolved = false;
    this.#isRejected = false;
    this.#isCancelled = false;
    this.#cancelHandlers = [];
    this.#promise = new Promise((resolve, reject) => {
      this.#resolve = resolve;
      this.#reject = reject;
      const onResolve = value => {
        if (this.#isResolved || this.#isRejected || this.#isCancelled) {
          return;
        }
        this.#isResolved = true;
        this.#resolve?.(value);
      };
      const onReject = reason => {
        if (this.#isResolved || this.#isRejected || this.#isCancelled) {
          return;
        }
        this.#isRejected = true;
        this.#reject?.(reason);
      };
      const onCancel = cancelHandler => {
        if (this.#isResolved || this.#isRejected || this.#isCancelled) {
          return;
        }
        this.#cancelHandlers.push(cancelHandler);
      };
      Object.defineProperty(onCancel, 'isResolved', {
        get: () => this.#isResolved
      });
      Object.defineProperty(onCancel, 'isRejected', {
        get: () => this.#isRejected
      });
      Object.defineProperty(onCancel, 'isCancelled', {
        get: () => this.#isCancelled
      });
      return executor(onResolve, onReject, onCancel);
    });
  }
  get [Symbol.toStringTag]() {
    return "Cancellable Promise";
  }
  then(onFulfilled, onRejected) {
    return this.#promise.then(onFulfilled, onRejected);
  }
  catch(onRejected) {
    return this.#promise.catch(onRejected);
  }
  finally(onFinally) {
    return this.#promise.finally(onFinally);
  }
  cancel() {
    if (this.#isResolved || this.#isRejected || this.#isCancelled) {
      return;
    }
    this.#isCancelled = true;
    if (this.#cancelHandlers.length) {
      try {
        for (const cancelHandler of this.#cancelHandlers) {
          cancelHandler();
        }
      } catch (error) {
        console.warn('Cancellation threw an error', error);
        return;
      }
    }
    this.#cancelHandlers.length = 0;
    this.#reject?.(new CancelError('Request aborted'));
  }
  get isCancelled() {
    return this.#isCancelled;
  }
}

/* generated using openapi-typescript-codegen -- do no edit */
const isDefined = value => {
  return value !== undefined && value !== null;
};
const isString = value => {
  return typeof value === 'string';
};
const isStringWithValue = value => {
  return isString(value) && value !== '';
};
const isBlob = value => {
  return typeof value === 'object' && typeof value.type === 'string' && typeof value.stream === 'function' && typeof value.arrayBuffer === 'function' && typeof value.constructor === 'function' && typeof value.constructor.name === 'string' && /^(Blob|File)$/.test(value.constructor.name) && /^(Blob|File)$/.test(value[Symbol.toStringTag]);
};
const isFormData = value => {
  return value instanceof FormData;
};
const base64 = str => {
  try {
    return btoa(str);
  } catch (err) {
    // @ts-ignore
    return Buffer.from(str).toString('base64');
  }
};
const getQueryString = params => {
  const qs = [];
  const append = (key, value) => {
    qs.push(`${encodeURIComponent(key)}=${encodeURIComponent(String(value))}`);
  };
  const process = (key, value) => {
    if (isDefined(value)) {
      if (Array.isArray(value)) {
        value.forEach(v => {
          process(key, v);
        });
      } else if (typeof value === 'object') {
        Object.entries(value).forEach(([k, v]) => {
          process(`${key}[${k}]`, v);
        });
      } else {
        append(key, value);
      }
    }
  };
  Object.entries(params).forEach(([key, value]) => {
    process(key, value);
  });
  if (qs.length > 0) {
    return `?${qs.join('&')}`;
  }
  return '';
};
const getUrl = (config, options) => {
  const encoder = config.ENCODE_PATH || encodeURI;
  const path = options.url.replace('{api-version}', config.VERSION).replace(/{(.*?)}/g, (substring, group) => {
    if (options.path?.hasOwnProperty(group)) {
      return encoder(String(options.path[group]));
    }
    return substring;
  });
  const url = `${config.BASE}${path}`;
  if (options.query) {
    return `${url}${getQueryString(options.query)}`;
  }
  return url;
};
const getFormData = options => {
  if (options.formData) {
    const formData = new FormData();
    const process = (key, value) => {
      if (isString(value) || isBlob(value)) {
        formData.append(key, value);
      } else {
        formData.append(key, JSON.stringify(value));
      }
    };
    Object.entries(options.formData).filter(([_, value]) => isDefined(value)).forEach(([key, value]) => {
      if (Array.isArray(value)) {
        value.forEach(v => process(key, v));
      } else {
        process(key, value);
      }
    });
    return formData;
  }
  return undefined;
};
const resolve = async (options, resolver) => {
  if (typeof resolver === 'function') {
    return resolver(options);
  }
  return resolver;
};
const getHeaders = async (config, options) => {
  const token = await resolve(options, config.TOKEN);
  const username = await resolve(options, config.USERNAME);
  const password = await resolve(options, config.PASSWORD);
  const additionalHeaders = await resolve(options, config.HEADERS);
  const headers = Object.entries({
    Accept: 'application/json',
    ...additionalHeaders,
    ...options.headers
  }).filter(([_, value]) => isDefined(value)).reduce((headers, [key, value]) => ({
    ...headers,
    [key]: String(value)
  }), {});
  if (isStringWithValue(token)) {
    headers['Authorization'] = `Bearer ${token}`;
  }
  if (isStringWithValue(username) && isStringWithValue(password)) {
    const credentials = base64(`${username}:${password}`);
    headers['Authorization'] = `Basic ${credentials}`;
  }
  if (options.body) {
    if (options.mediaType) {
      headers['Content-Type'] = options.mediaType;
    } else if (isBlob(options.body)) {
      headers['Content-Type'] = options.body.type || 'application/octet-stream';
    } else if (isString(options.body)) {
      headers['Content-Type'] = 'text/plain';
    } else if (!isFormData(options.body)) {
      headers['Content-Type'] = 'application/json';
    }
  }
  return new Headers(headers);
};
const getRequestBody = options => {
  if (options.body !== undefined) {
    if (options.mediaType?.includes('/json')) {
      return JSON.stringify(options.body);
    } else if (isString(options.body) || isBlob(options.body) || isFormData(options.body)) {
      return options.body;
    } else {
      return JSON.stringify(options.body);
    }
  }
  return undefined;
};
const sendRequest = async (config, options, url, body, formData, headers, onCancel) => {
  const controller = new AbortController();
  const request = {
    headers,
    body: body ?? formData,
    method: options.method,
    signal: controller.signal
  };
  if (config.WITH_CREDENTIALS) {
    request.credentials = config.CREDENTIALS;
  }
  onCancel(() => controller.abort());
  return await fetch(url, request);
};
const getResponseHeader = (response, responseHeader) => {
  if (responseHeader) {
    const content = response.headers.get(responseHeader);
    if (isString(content)) {
      return content;
    }
  }
  return undefined;
};
const getResponseBody = async response => {
  if (response.status !== 204) {
    try {
      const contentType = response.headers.get('Content-Type');
      if (contentType) {
        const jsonTypes = ['application/json', 'application/problem+json'];
        const isJSON = jsonTypes.some(type => contentType.toLowerCase().startsWith(type));
        if (isJSON) {
          return await response.json();
        } else {
          return await response.text();
        }
      }
    } catch (error) {
      console.error(error);
    }
  }
  return undefined;
};
const catchErrorCodes = (options, result) => {
  const errors = {
    400: 'Bad Request',
    401: 'Unauthorized',
    403: 'Forbidden',
    404: 'Not Found',
    500: 'Internal Server Error',
    502: 'Bad Gateway',
    503: 'Service Unavailable',
    ...options.errors
  };
  const error = errors[result.status];
  if (error) {
    throw new ApiError(options, result, error);
  }
  if (!result.ok) {
    const errorStatus = result.status ?? 'unknown';
    const errorStatusText = result.statusText ?? 'unknown';
    const errorBody = (() => {
      try {
        return JSON.stringify(result.body, null, 2);
      } catch (e) {
        return undefined;
      }
    })();
    throw new ApiError(options, result, `Generic Error: status: ${errorStatus}; status text: ${errorStatusText}; body: ${errorBody}`);
  }
};

/**
 * Request method
 * @param config The OpenAPI configuration object
 * @param options The request options from the service
 * @returns CancelablePromise<T>
 * @throws ApiError
 */
const request = (config, options) => {
  return new CancelablePromise(async (resolve, reject, onCancel) => {
    try {
      const url = getUrl(config, options);
      const formData = getFormData(options);
      const body = getRequestBody(options);
      const headers = await getHeaders(config, options);
      if (!onCancel.isCancelled) {
        const response = await sendRequest(config, options, url, body, formData, headers, onCancel);
        const responseBody = await getResponseBody(response);
        const responseHeader = getResponseHeader(response, options.responseHeader);
        const result = {
          url,
          ok: response.ok,
          status: response.status,
          statusText: response.statusText,
          body: responseHeader ?? responseBody
        };
        catchErrorCodes(options, result);
        resolve(result.body);
      }
    } catch (error) {
      reject(error);
    }
  });
};

/* generated using openapi-typescript-codegen -- do no edit */
class FetchHttpRequest extends BaseHttpRequest {
  constructor(config) {
    super(config);
  }

  /**
   * Request method
   * @param options The request options from the service
   * @returns CancelablePromise<T>
   * @throws ApiError
   */
  request(options) {
    return request(this.config, options);
  }
}

/* generated using openapi-typescript-codegen -- do no edit */
/* istanbul ignore file */
/* tslint:disable */
/* eslint-disable */

class AccessTokensService {
  constructor(httpRequest) {
    this.httpRequest = httpRequest;
  }

  /**
   * Get all access tokens
   * Get all access tokens
   * @returns any Default Response
   * @throws ApiError
   */
  getAll() {
    return this.httpRequest.request({
      method: 'GET',
      url: '/auth/access-tokens/get-all'
    });
  }

  /**
   * Create a new access token
   * Create a new access token
   * @param requestBody
   * @returns any Default Response
   * @throws ApiError
   */
  create(requestBody) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/auth/access-tokens/create',
      body: requestBody,
      mediaType: 'application/json'
    });
  }

  /**
   * Revoke an access token
   * Revoke an access token
   * @param requestBody
   * @returns any Default Response
   * @throws ApiError
   */
  revoke(requestBody) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/auth/access-tokens/revoke',
      body: requestBody,
      mediaType: 'application/json'
    });
  }
}

/* generated using openapi-typescript-codegen -- do no edit */
/* istanbul ignore file */
/* tslint:disable */
/* eslint-disable */

class AccountService {
  constructor(httpRequest) {
    this.httpRequest = httpRequest;
  }

  /**
   * Get all admins
   * Get all admins for a smart account.
   * @param chain Chain ID or name
   * @param contractAddress Contract address on the chain
   * @returns any Default Response
   * @throws ApiError
   */
  getAllAdmins(chain, contractAddress) {
    return this.httpRequest.request({
      method: 'GET',
      url: '/contract/{chain}/{contractAddress}/account/admins/get-all',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Get all session keys
   * Get all session keys for a smart account.
   * @param chain Chain ID or name
   * @param contractAddress Contract address on the chain
   * @returns any Default Response
   * @throws ApiError
   */
  getAllSessions(chain, contractAddress) {
    return this.httpRequest.request({
      method: 'GET',
      url: '/contract/{chain}/{contractAddress}/account/sessions/get-all',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Grant admin
   * Grant a smart account's admin permission.
   * @param chain Chain ID or name
   * @param contractAddress Contract address on the chain
   * @param xBackendWalletAddress Backend wallet address
   * @param requestBody
   * @param xAccountAddress Smart account address
   * @returns any Default Response
   * @throws ApiError
   */
  grantAdmin(chain, contractAddress, xBackendWalletAddress, requestBody, xAccountAddress) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/contract/{chain}/{contractAddress}/account/admins/grant',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      headers: {
        'x-backend-wallet-address': xBackendWalletAddress,
        'x-account-address': xAccountAddress
      },
      body: requestBody,
      mediaType: 'application/json',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Revoke admin
   * Revoke a smart account's admin permission.
   * @param chain Chain ID or name
   * @param contractAddress Contract address on the chain
   * @param xBackendWalletAddress Backend wallet address
   * @param requestBody
   * @param xAccountAddress Smart account address
   * @returns any Default Response
   * @throws ApiError
   */
  revokeAdmin(chain, contractAddress, xBackendWalletAddress, requestBody, xAccountAddress) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/contract/{chain}/{contractAddress}/account/admins/revoke',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      headers: {
        'x-backend-wallet-address': xBackendWalletAddress,
        'x-account-address': xAccountAddress
      },
      body: requestBody,
      mediaType: 'application/json',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Create session key
   * Create a session key for a smart account.
   * @param chain Chain ID or name
   * @param contractAddress Contract address on the chain
   * @param xBackendWalletAddress Backend wallet address
   * @param requestBody
   * @param xAccountAddress Smart account address
   * @returns any Default Response
   * @throws ApiError
   */
  grantSession(chain, contractAddress, xBackendWalletAddress, requestBody, xAccountAddress) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/contract/{chain}/{contractAddress}/account/sessions/create',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      headers: {
        'x-backend-wallet-address': xBackendWalletAddress,
        'x-account-address': xAccountAddress
      },
      body: requestBody,
      mediaType: 'application/json',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Revoke session key
   * Revoke a session key for a smart account.
   * @param chain Chain ID or name
   * @param contractAddress Contract address on the chain
   * @param xBackendWalletAddress Backend wallet address
   * @param requestBody
   * @param xAccountAddress Smart account address
   * @returns any Default Response
   * @throws ApiError
   */
  revokeSession(chain, contractAddress, xBackendWalletAddress, requestBody, xAccountAddress) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/contract/{chain}/{contractAddress}/account/sessions/revoke',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      headers: {
        'x-backend-wallet-address': xBackendWalletAddress,
        'x-account-address': xAccountAddress
      },
      body: requestBody,
      mediaType: 'application/json',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Update session key
   * Update a session key for a smart account.
   * @param chain Chain ID or name
   * @param contractAddress Contract address on the chain
   * @param xBackendWalletAddress Backend wallet address
   * @param requestBody
   * @param xAccountAddress Smart account address
   * @returns any Default Response
   * @throws ApiError
   */
  updateSession(chain, contractAddress, xBackendWalletAddress, requestBody, xAccountAddress) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/contract/{chain}/{contractAddress}/account/sessions/update',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      headers: {
        'x-backend-wallet-address': xBackendWalletAddress,
        'x-account-address': xAccountAddress
      },
      body: requestBody,
      mediaType: 'application/json',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }
}

/* generated using openapi-typescript-codegen -- do no edit */
/* istanbul ignore file */
/* tslint:disable */
/* eslint-disable */

class AccountFactoryService {
  constructor(httpRequest) {
    this.httpRequest = httpRequest;
  }

  /**
   * Get all smart accounts
   * Get all the smart accounts for this account factory.
   * @param chain Chain ID or name
   * @param contractAddress Contract address on the chain
   * @returns any Default Response
   * @throws ApiError
   */
  getAllAccounts(chain, contractAddress) {
    return this.httpRequest.request({
      method: 'GET',
      url: '/contract/{chain}/{contractAddress}/account-factory/get-all-accounts',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Get associated smart accounts
   * Get all the smart accounts for this account factory associated with the specific admin wallet.
   * @param signerAddress The address of the signer to get associated accounts from
   * @param chain Chain ID or name
   * @param contractAddress Contract address on the chain
   * @returns any Default Response
   * @throws ApiError
   */
  getAssociatedAccounts(signerAddress, chain, contractAddress) {
    return this.httpRequest.request({
      method: 'GET',
      url: '/contract/{chain}/{contractAddress}/account-factory/get-associated-accounts',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      query: {
        'signerAddress': signerAddress
      },
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Check if deployed
   * Check if a smart account has been deployed to the blockchain.
   * @param adminAddress The address of the admin to check if the account address is deployed
   * @param chain Chain ID or name
   * @param contractAddress Contract address on the chain
   * @param extraData Extra data to use in predicting the account address
   * @returns any Default Response
   * @throws ApiError
   */
  isAccountDeployed(adminAddress, chain, contractAddress, extraData) {
    return this.httpRequest.request({
      method: 'GET',
      url: '/contract/{chain}/{contractAddress}/account-factory/is-account-deployed',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      query: {
        'adminAddress': adminAddress,
        'extraData': extraData
      },
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Predict smart account address
   * Get the counterfactual address of a smart account.
   * @param adminAddress The address of the admin to predict the account address for
   * @param chain Chain ID or name
   * @param contractAddress Contract address on the chain
   * @param extraData Extra data to add to use in predicting the account address
   * @returns any Default Response
   * @throws ApiError
   */
  predictAccountAddress(adminAddress, chain, contractAddress, extraData) {
    return this.httpRequest.request({
      method: 'GET',
      url: '/contract/{chain}/{contractAddress}/account-factory/predict-account-address',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      query: {
        'adminAddress': adminAddress,
        'extraData': extraData
      },
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Create smart account
   * Create a smart account for this account factory.
   * @param chain Chain ID or name
   * @param contractAddress Contract address on the chain
   * @param xBackendWalletAddress Backend wallet address
   * @param requestBody
   * @param xAccountAddress Smart account address
   * @returns any Default Response
   * @throws ApiError
   */
  createAccount(chain, contractAddress, xBackendWalletAddress, requestBody, xAccountAddress) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/contract/{chain}/{contractAddress}/account-factory/create-account',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      headers: {
        'x-backend-wallet-address': xBackendWalletAddress,
        'x-account-address': xAccountAddress
      },
      body: requestBody,
      mediaType: 'application/json',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }
}

/* generated using openapi-typescript-codegen -- do no edit */
/* istanbul ignore file */
/* tslint:disable */
/* eslint-disable */

class BackendWalletService {
  constructor(httpRequest) {
    this.httpRequest = httpRequest;
  }

  /**
   * Create backend wallet
   * Create a backend wallet.
   * @param requestBody
   * @returns any Default Response
   * @throws ApiError
   */
  create(requestBody) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/backend-wallet/create',
      body: requestBody,
      mediaType: 'application/json',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Import backend wallet
   * Import an existing wallet as a backend wallet.
   * @param requestBody
   * @returns any Default Response
   * @throws ApiError
   */
  import(requestBody) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/backend-wallet/import',
      body: requestBody,
      mediaType: 'application/json',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Get balance
   * Get the native balance for a backend wallet.
   * @param chain Chain ID name
   * @param walletAddress Wallet Address
   * @returns any Default Response
   * @throws ApiError
   */
  getBalance(chain, walletAddress) {
    return this.httpRequest.request({
      method: 'GET',
      url: '/backend-wallet/{chain}/{walletAddress}/get-balance',
      path: {
        'chain': chain,
        'walletAddress': walletAddress
      },
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Get all backend wallets
   * Get all backend wallets.
   * @returns any Default Response
   * @throws ApiError
   */
  getAll() {
    return this.httpRequest.request({
      method: 'GET',
      url: '/backend-wallet/get-all',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Transfer tokens
   * Transfer native or ERC20 tokens from this wallet to another wallet
   * @param chain Chain ID name
   * @param xBackendWalletAddress Backend wallet address
   * @param requestBody
   * @returns any Default Response
   * @throws ApiError
   */
  transfer(chain, xBackendWalletAddress, requestBody) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/backend-wallet/{chain}/transfer',
      path: {
        'chain': chain
      },
      headers: {
        'x-backend-wallet-address': xBackendWalletAddress
      },
      body: requestBody,
      mediaType: 'application/json',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Send a raw transaction
   * Send a raw transaction with transaction parameters
   * @param chain
   * @param xBackendWalletAddress Backend wallet address
   * @param requestBody
   * @returns any Default Response
   * @throws ApiError
   */
  sendTransaction(chain, xBackendWalletAddress, requestBody) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/backend-wallet/{chain}/send-transaction',
      path: {
        'chain': chain
      },
      headers: {
        'x-backend-wallet-address': xBackendWalletAddress
      },
      body: requestBody,
      mediaType: 'application/json',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }
}

/* generated using openapi-typescript-codegen -- do no edit */
/* istanbul ignore file */
/* tslint:disable */
/* eslint-disable */

class ChainService {
  constructor(httpRequest) {
    this.httpRequest = httpRequest;
  }

  /**
   * Get chain details
   * Get details about a chain.
   * @param chain Chain name or id
   * @returns any Default Response
   * @throws ApiError
   */
  get(chain) {
    return this.httpRequest.request({
      method: 'GET',
      url: '/chain/get',
      query: {
        'chain': chain
      },
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Get all chain details
   * Get details about all supported chains.
   * @returns any Default Response
   * @throws ApiError
   */
  getAll() {
    return this.httpRequest.request({
      method: 'GET',
      url: '/chain/get-all',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }
}

/* generated using openapi-typescript-codegen -- do no edit */
/* istanbul ignore file */
/* tslint:disable */
/* eslint-disable */

class ConfigurationService {
  constructor(httpRequest) {
    this.httpRequest = httpRequest;
  }

  /**
   * Get wallets configuration
   * Get the engine configuration for wallets
   * @returns any Default Response
   * @throws ApiError
   */
  getWalletsConfiguration() {
    return this.httpRequest.request({
      method: 'GET',
      url: '/configuration/wallets'
    });
  }

  /**
   * Update wallets configuration
   * Update the engine configuration for wallets
   * @param requestBody
   * @returns any Default Response
   * @throws ApiError
   */
  updateWalletsConfiguration(requestBody) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/configuration/wallets',
      body: requestBody,
      mediaType: 'application/json'
    });
  }

  /**
   * Get chain overrides configuration
   * Get the engine configuration for chain overrides
   * @returns any Default Response
   * @throws ApiError
   */
  getChainsConfiguration() {
    return this.httpRequest.request({
      method: 'GET',
      url: '/configuration/chains'
    });
  }

  /**
   * Update chain overrides configuration
   * Update the engine configuration for chain overrides
   * @param requestBody
   * @returns any Default Response
   * @throws ApiError
   */
  updateChainsConfiguration(requestBody) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/configuration/chains',
      body: requestBody,
      mediaType: 'application/json'
    });
  }

  /**
   * Get transaction processing configuration
   * Get the engine configuration for processing transactions
   * @returns any Default Response
   * @throws ApiError
   */
  getTransactionConfiguration() {
    return this.httpRequest.request({
      method: 'GET',
      url: '/configuration/transactions'
    });
  }

  /**
   * Update transaction processing configuration
   * Update the engine configuration for processing transactions
   * @param requestBody
   * @returns any Default Response
   * @throws ApiError
   */
  updateTransactionConfiguration(requestBody) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/configuration/transactions',
      body: requestBody,
      mediaType: 'application/json'
    });
  }

  /**
   * Get auth configuration
   * Get the engine configuration for auth
   * @returns any Default Response
   * @throws ApiError
   */
  getAuthConfiguration() {
    return this.httpRequest.request({
      method: 'GET',
      url: '/configuration/auth'
    });
  }

  /**
   * Update auth configuration
   * Update the engine configuration for auth
   * @param requestBody
   * @returns any Default Response
   * @throws ApiError
   */
  updateAuthConfiguration(requestBody) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/configuration/auth',
      body: requestBody,
      mediaType: 'application/json'
    });
  }

  /**
   * Get wallet-balance configuration
   * Get wallet-balance configuration
   * @returns any Default Response
   * @throws ApiError
   */
  getBackendWalletBalanceConfiguration() {
    return this.httpRequest.request({
      method: 'GET',
      url: '/configuration/backend-wallet-balance',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Update backend wallet balance configuration
   * Update backend wallet balance configuration
   * @param requestBody
   * @returns any Default Response
   * @throws ApiError
   */
  updateBackendWalletBalanceConfiguration(requestBody) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/configuration/backend-wallet-balance',
      body: requestBody,
      mediaType: 'application/json',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }
}

/* generated using openapi-typescript-codegen -- do no edit */
/* istanbul ignore file */
/* tslint:disable */
/* eslint-disable */

class ContractService {
  constructor(httpRequest) {
    this.httpRequest = httpRequest;
  }

  /**
   * Read from contract
   * Call a read function on a contract.
   * @param functionName Name of the function to call on Contract
   * @param chain Chain ID or name
   * @param contractAddress Contract address on the chain
   * @param args Arguments for the function. Comma Separated
   * @returns any Default Response
   * @throws ApiError
   */
  read(functionName, chain, contractAddress, args) {
    return this.httpRequest.request({
      method: 'GET',
      url: '/contract/{chain}/{contractAddress}/read',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      query: {
        'functionName': functionName,
        'args': args
      },
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Write to contract
   * Call a write function on a contract.
   * @param chain Chain ID or name
   * @param contractAddress Contract address on the chain
   * @param xBackendWalletAddress Backend wallet address
   * @param requestBody
   * @param xAccountAddress Smart account address
   * @returns any Default Response
   * @throws ApiError
   */
  write(chain, contractAddress, xBackendWalletAddress, requestBody, xAccountAddress) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/contract/{chain}/{contractAddress}/write',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      headers: {
        'x-backend-wallet-address': xBackendWalletAddress,
        'x-account-address': xAccountAddress
      },
      body: requestBody,
      mediaType: 'application/json',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }
}

/* generated using openapi-typescript-codegen -- do no edit */
/* istanbul ignore file */
/* tslint:disable */
/* eslint-disable */

class ContractEventsService {
  constructor(httpRequest) {
    this.httpRequest = httpRequest;
  }

  /**
   * Get all events
   * Get a list of all blockchain events for this contract.
   * @param chain Chain ID or name
   * @param contractAddress Contract address on the chain
   * @param fromBlock
   * @param toBlock
   * @param order
   * @returns any Default Response
   * @throws ApiError
   */
  getAllEvents(chain, contractAddress, fromBlock, toBlock, order) {
    return this.httpRequest.request({
      method: 'GET',
      url: '/contract/{chain}/{contractAddress}/events/get-all',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      query: {
        'fromBlock': fromBlock,
        'toBlock': toBlock,
        'order': order
      },
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Get events
   * Get a list of specific blockchain events emitted from this contract.
   * @param chain Chain ID or name
   * @param contractAddress Contract address on the chain
   * @param requestBody Specify the from and to block numbers to get events for, defaults to all blocks
   * @returns any Default Response
   * @throws ApiError
   */
  getEvents(chain, contractAddress, requestBody) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/contract/{chain}/{contractAddress}/events/get',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      body: requestBody,
      mediaType: 'application/json',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }
}

/* generated using openapi-typescript-codegen -- do no edit */
/* istanbul ignore file */
/* tslint:disable */
/* eslint-disable */

class ContractMetadataService {
  constructor(httpRequest) {
    this.httpRequest = httpRequest;
  }

  /**
   * Get ABI
   * Get the ABI of a contract.
   * @param chain Chain ID or name
   * @param contractAddress Contract address on the chain
   * @returns any Default Response
   * @throws ApiError
   */
  getAbi(chain, contractAddress) {
    return this.httpRequest.request({
      method: 'GET',
      url: '/contract/{chain}/{contractAddress}/metadata/abi',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Get events
   * Get details of all events implemented by a contract.
   * @param chain Chain ID or name
   * @param contractAddress Contract address on the chain
   * @returns any Default Response
   * @throws ApiError
   */
  getEvents(chain, contractAddress) {
    return this.httpRequest.request({
      method: 'GET',
      url: '/contract/{chain}/{contractAddress}/metadata/events',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Get extensions
   * Get all detected extensions for a contract.
   * @param chain Chain ID or name
   * @param contractAddress Contract address on the chain
   * @returns any Default Response
   * @throws ApiError
   */
  getExtensions(chain, contractAddress) {
    return this.httpRequest.request({
      method: 'GET',
      url: '/contract/{chain}/{contractAddress}/metadata/extensions',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Get functions
   * Get details of all functions implemented by the contract.
   * @param chain Chain ID or name
   * @param contractAddress Contract address on the chain
   * @returns any Default Response
   * @throws ApiError
   */
  getFunctions(chain, contractAddress) {
    return this.httpRequest.request({
      method: 'GET',
      url: '/contract/{chain}/{contractAddress}/metadata/functions',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }
}

/* generated using openapi-typescript-codegen -- do no edit */
/* istanbul ignore file */
/* tslint:disable */
/* eslint-disable */

class ContractRolesService {
  constructor(httpRequest) {
    this.httpRequest = httpRequest;
  }

  /**
   * Get wallets for role
   * Get all wallets with a specific role for a contract.
   * @param role The role to list wallet members
   * @param chain Chain ID or name
   * @param contractAddress Contract address on the chain
   * @returns any Default Response
   * @throws ApiError
   */
  getRole(role, chain, contractAddress) {
    return this.httpRequest.request({
      method: 'GET',
      url: '/contract/{chain}/{contractAddress}/roles/get',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      query: {
        'role': role
      },
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Get wallets for all roles
   * Get all wallets in each role for a contract.
   * @param chain Chain ID or name
   * @param contractAddress Contract address on the chain
   * @returns any Default Response
   * @throws ApiError
   */
  getAll(chain, contractAddress) {
    return this.httpRequest.request({
      method: 'GET',
      url: '/contract/{chain}/{contractAddress}/roles/get-all',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Grant role
   * Grant a role to a specific wallet.
   * @param chain Chain ID or name
   * @param contractAddress Contract address on the chain
   * @param xBackendWalletAddress Backend wallet address
   * @param requestBody
   * @param xAccountAddress Smart account address
   * @returns any Default Response
   * @throws ApiError
   */
  grant(chain, contractAddress, xBackendWalletAddress, requestBody, xAccountAddress) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/contract/{chain}/{contractAddress}/roles/grant',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      headers: {
        'x-backend-wallet-address': xBackendWalletAddress,
        'x-account-address': xAccountAddress
      },
      body: requestBody,
      mediaType: 'application/json',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Revoke role
   * Revoke a role from a specific wallet.
   * @param chain Chain ID or name
   * @param contractAddress Contract address on the chain
   * @param xBackendWalletAddress Backend wallet address
   * @param requestBody
   * @param xAccountAddress Smart account address
   * @returns any Default Response
   * @throws ApiError
   */
  revoke(chain, contractAddress, xBackendWalletAddress, requestBody, xAccountAddress) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/contract/{chain}/{contractAddress}/roles/revoke',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      headers: {
        'x-backend-wallet-address': xBackendWalletAddress,
        'x-account-address': xAccountAddress
      },
      body: requestBody,
      mediaType: 'application/json',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }
}

/* generated using openapi-typescript-codegen -- do no edit */
/* istanbul ignore file */
/* tslint:disable */
/* eslint-disable */

class ContractRoyaltiesService {
  constructor(httpRequest) {
    this.httpRequest = httpRequest;
  }

  /**
   * Get royalty details
   * Gets the royalty recipient and BPS (basis points) of the smart contract.
   * @param chain Chain ID or name
   * @param contractAddress Contract address on the chain
   * @returns any Default Response
   * @throws ApiError
   */
  getDefaultRoyaltyInfo(chain, contractAddress) {
    return this.httpRequest.request({
      method: 'GET',
      url: '/contract/{chain}/{contractAddress}/royalties/get-default-royalty-info',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Get token royalty details
   * Gets the royalty recipient and BPS (basis points) of a particular token in the contract.
   * @param tokenId
   * @param chain Chain ID or name
   * @param contractAddress Contract address on the chain
   * @returns any Default Response
   * @throws ApiError
   */
  getTokenRoyaltyInfo(tokenId, chain, contractAddress) {
    return this.httpRequest.request({
      method: 'GET',
      url: '/contract/{chain}/{contractAddress}/royalties/get-token-royalty-info/{token_id}',
      path: {
        'tokenId': tokenId,
        'chain': chain,
        'contractAddress': contractAddress
      },
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Set royalty details
   * Set the royalty recipient and fee for the smart contract.
   * @param chain Chain ID or name
   * @param contractAddress Contract address on the chain
   * @param xBackendWalletAddress Backend wallet address
   * @param requestBody
   * @param xAccountAddress Smart account address
   * @returns any Default Response
   * @throws ApiError
   */
  setDefaultRoyaltyInfo(chain, contractAddress, xBackendWalletAddress, requestBody, xAccountAddress) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/contract/{chain}/{contractAddress}/royalties/set-default-royalty-info',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      headers: {
        'x-backend-wallet-address': xBackendWalletAddress,
        'x-account-address': xAccountAddress
      },
      body: requestBody,
      mediaType: 'application/json',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Set token royalty details
   * Set the royalty recipient and fee for a particular token in the contract.
   * @param chain Chain ID or name
   * @param contractAddress Contract address on the chain
   * @param xBackendWalletAddress Backend wallet address
   * @param requestBody
   * @param xAccountAddress Smart account address
   * @returns any Default Response
   * @throws ApiError
   */
  setTokenRoyaltyInfo(chain, contractAddress, xBackendWalletAddress, requestBody, xAccountAddress) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/contract/{chain}/{contractAddress}/royalties/set-token-royalty-info',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      headers: {
        'x-backend-wallet-address': xBackendWalletAddress,
        'x-account-address': xAccountAddress
      },
      body: requestBody,
      mediaType: 'application/json',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }
}

/* generated using openapi-typescript-codegen -- do no edit */
/* istanbul ignore file */
/* tslint:disable */
/* eslint-disable */

class DefaultService {
  constructor(httpRequest) {
    this.httpRequest = httpRequest;
  }

  /**
   * @returns any Default Response
   * @throws ApiError
   */
  getHealth() {
    return this.httpRequest.request({
      method: 'GET',
      url: '/health'
    });
  }
}

/* generated using openapi-typescript-codegen -- do no edit */
/* istanbul ignore file */
/* tslint:disable */
/* eslint-disable */

class DeployService {
  constructor(httpRequest) {
    this.httpRequest = httpRequest;
  }

  /**
   * Deploy Edition
   * Deploy an Edition contract.
   * @param chain Chain ID or name
   * @param xBackendWalletAddress Backend wallet address
   * @param requestBody
   * @param xAccountAddress Smart account address
   * @returns any Default Response
   * @throws ApiError
   */
  deployEdition(chain, xBackendWalletAddress, requestBody, xAccountAddress) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/deploy/{chain}/prebuilts/edition',
      path: {
        'chain': chain
      },
      headers: {
        'x-backend-wallet-address': xBackendWalletAddress,
        'x-account-address': xAccountAddress
      },
      body: requestBody,
      mediaType: 'application/json',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Deploy Edition Drop
   * Deploy an Edition Drop contract.
   * @param chain Chain ID or name
   * @param xBackendWalletAddress Backend wallet address
   * @param requestBody
   * @param xAccountAddress Smart account address
   * @returns any Default Response
   * @throws ApiError
   */
  deployEditionDrop(chain, xBackendWalletAddress, requestBody, xAccountAddress) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/deploy/{chain}/prebuilts/edition-drop',
      path: {
        'chain': chain
      },
      headers: {
        'x-backend-wallet-address': xBackendWalletAddress,
        'x-account-address': xAccountAddress
      },
      body: requestBody,
      mediaType: 'application/json',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Deploy Marketplace
   * Deploy a Marketplace contract.
   * @param chain Chain ID or name
   * @param xBackendWalletAddress Backend wallet address
   * @param requestBody
   * @param xAccountAddress Smart account address
   * @returns any Default Response
   * @throws ApiError
   */
  deployMarketplaceV3(chain, xBackendWalletAddress, requestBody, xAccountAddress) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/deploy/{chain}/prebuilts/marketplace-v3',
      path: {
        'chain': chain
      },
      headers: {
        'x-backend-wallet-address': xBackendWalletAddress,
        'x-account-address': xAccountAddress
      },
      body: requestBody,
      mediaType: 'application/json',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Deploy Multiwrap
   * Deploy a Multiwrap contract.
   * @param chain Chain ID or name
   * @param xBackendWalletAddress Backend wallet address
   * @param requestBody
   * @param xAccountAddress Smart account address
   * @returns any Default Response
   * @throws ApiError
   */
  deployMultiwrap(chain, xBackendWalletAddress, requestBody, xAccountAddress) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/deploy/{chain}/prebuilts/multiwrap',
      path: {
        'chain': chain
      },
      headers: {
        'x-backend-wallet-address': xBackendWalletAddress,
        'x-account-address': xAccountAddress
      },
      body: requestBody,
      mediaType: 'application/json',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Deploy NFT Collection
   * Deploy an NFT Collection contract.
   * @param chain Chain ID or name
   * @param xBackendWalletAddress Backend wallet address
   * @param requestBody
   * @param xAccountAddress Smart account address
   * @returns any Default Response
   * @throws ApiError
   */
  deployNftCollection(chain, xBackendWalletAddress, requestBody, xAccountAddress) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/deploy/{chain}/prebuilts/nft-collection',
      path: {
        'chain': chain
      },
      headers: {
        'x-backend-wallet-address': xBackendWalletAddress,
        'x-account-address': xAccountAddress
      },
      body: requestBody,
      mediaType: 'application/json',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Deploy NFT Drop
   * Deploy an NFT Drop contract.
   * @param chain Chain ID or name
   * @param xBackendWalletAddress Backend wallet address
   * @param requestBody
   * @param xAccountAddress Smart account address
   * @returns any Default Response
   * @throws ApiError
   */
  deployNftDrop(chain, xBackendWalletAddress, requestBody, xAccountAddress) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/deploy/{chain}/prebuilts/nft-drop',
      path: {
        'chain': chain
      },
      headers: {
        'x-backend-wallet-address': xBackendWalletAddress,
        'x-account-address': xAccountAddress
      },
      body: requestBody,
      mediaType: 'application/json',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Deploy Pack
   * Deploy a Pack contract.
   * @param chain Chain ID or name
   * @param xBackendWalletAddress Backend wallet address
   * @param requestBody
   * @param xAccountAddress Smart account address
   * @returns any Default Response
   * @throws ApiError
   */
  deployPack(chain, xBackendWalletAddress, requestBody, xAccountAddress) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/deploy/{chain}/prebuilts/pack',
      path: {
        'chain': chain
      },
      headers: {
        'x-backend-wallet-address': xBackendWalletAddress,
        'x-account-address': xAccountAddress
      },
      body: requestBody,
      mediaType: 'application/json',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Deploy Signature Drop
   * Deploy a Signature Drop contract.
   * @param chain Chain ID or name
   * @param xBackendWalletAddress Backend wallet address
   * @param requestBody
   * @param xAccountAddress Smart account address
   * @returns any Default Response
   * @throws ApiError
   */
  deploySignatureDrop(chain, xBackendWalletAddress, requestBody, xAccountAddress) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/deploy/{chain}/prebuilts/signature-drop',
      path: {
        'chain': chain
      },
      headers: {
        'x-backend-wallet-address': xBackendWalletAddress,
        'x-account-address': xAccountAddress
      },
      body: requestBody,
      mediaType: 'application/json',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Deploy Split
   * Deploy a Split contract.
   * @param chain Chain ID or name
   * @param xBackendWalletAddress Backend wallet address
   * @param requestBody
   * @param xAccountAddress Smart account address
   * @returns any Default Response
   * @throws ApiError
   */
  deploySplit(chain, xBackendWalletAddress, requestBody, xAccountAddress) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/deploy/{chain}/prebuilts/split',
      path: {
        'chain': chain
      },
      headers: {
        'x-backend-wallet-address': xBackendWalletAddress,
        'x-account-address': xAccountAddress
      },
      body: requestBody,
      mediaType: 'application/json',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Deploy Token
   * Deploy a Token contract.
   * @param chain Chain ID or name
   * @param xBackendWalletAddress Backend wallet address
   * @param requestBody
   * @param xAccountAddress Smart account address
   * @returns any Default Response
   * @throws ApiError
   */
  deployToken(chain, xBackendWalletAddress, requestBody, xAccountAddress) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/deploy/{chain}/prebuilts/token',
      path: {
        'chain': chain
      },
      headers: {
        'x-backend-wallet-address': xBackendWalletAddress,
        'x-account-address': xAccountAddress
      },
      body: requestBody,
      mediaType: 'application/json',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Deploy Token Drop
   * Deploy a Token Drop contract.
   * @param chain Chain ID or name
   * @param xBackendWalletAddress Backend wallet address
   * @param requestBody
   * @param xAccountAddress Smart account address
   * @returns any Default Response
   * @throws ApiError
   */
  deployTokenDrop(chain, xBackendWalletAddress, requestBody, xAccountAddress) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/deploy/{chain}/prebuilts/token-drop',
      path: {
        'chain': chain
      },
      headers: {
        'x-backend-wallet-address': xBackendWalletAddress,
        'x-account-address': xAccountAddress
      },
      body: requestBody,
      mediaType: 'application/json',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Deploy Vote
   * Deploy a Vote contract.
   * @param chain Chain ID or name
   * @param xBackendWalletAddress Backend wallet address
   * @param requestBody
   * @param xAccountAddress Smart account address
   * @returns any Default Response
   * @throws ApiError
   */
  deployVote(chain, xBackendWalletAddress, requestBody, xAccountAddress) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/deploy/{chain}/prebuilts/vote',
      path: {
        'chain': chain
      },
      headers: {
        'x-backend-wallet-address': xBackendWalletAddress,
        'x-account-address': xAccountAddress
      },
      body: requestBody,
      mediaType: 'application/json',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Deploy published contract
   * Deploy a published contract to the blockchain.
   * @param chain Chain ID or name
   * @param publisher Address or ENS of the publisher of the contract
   * @param contractName Name of the published contract to deploy
   * @param xBackendWalletAddress Backend wallet address
   * @param requestBody
   * @param xAccountAddress Smart account address
   * @returns any Default Response
   * @throws ApiError
   */
  deployPublished(chain, publisher, contractName, xBackendWalletAddress, requestBody, xAccountAddress) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/deploy/{chain}/{publisher}/{contract_name}',
      path: {
        'chain': chain,
        'publisher': publisher,
        'contractName': contractName
      },
      headers: {
        'x-backend-wallet-address': xBackendWalletAddress,
        'x-account-address': xAccountAddress
      },
      body: requestBody,
      mediaType: 'application/json',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Get contract types
   * Get all prebuilt contract types.
   * @returns any Default Response
   * @throws ApiError
   */
  contractTypes() {
    return this.httpRequest.request({
      method: 'GET',
      url: '/deploy/contract-types',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }
}

/* generated using openapi-typescript-codegen -- do no edit */
/* istanbul ignore file */
/* tslint:disable */
/* eslint-disable */

class Erc1155Service {
  constructor(httpRequest) {
    this.httpRequest = httpRequest;
  }

  /**
   * Get details
   * Get the details for a token in an ERC-1155 contract.
   * @param tokenId The tokenId of the NFT to retrieve
   * @param chain Chain ID or name
   * @param contractAddress ERC1155 Contract Address on the Chain
   * @returns any Default Response
   * @throws ApiError
   */
  get(tokenId, chain, contractAddress) {
    return this.httpRequest.request({
      method: 'GET',
      url: '/contract/{chain}/{contractAddress}/erc1155/get',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      query: {
        'tokenId': tokenId
      },
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Get all details
   * Get details for all tokens in an ERC-1155 contract.
   * @param chain Chain ID or name
   * @param contractAddress ERC1155 Contract Address on the Chain
   * @param start The start token id for paginated results. Defaults to 0.
   * @param count The page count for paginated results. Defaults to 100.
   * @returns any Default Response
   * @throws ApiError
   */
  getAll(chain, contractAddress, start, count) {
    return this.httpRequest.request({
      method: 'GET',
      url: '/contract/{chain}/{contractAddress}/erc1155/get-all',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      query: {
        'start': start,
        'count': count
      },
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Get owned tokens
   * Get all tokens in an ERC-1155 contract owned by a specific wallet.
   * @param walletAddress Address of the wallet to get NFTs for
   * @param chain Chain ID or name
   * @param contractAddress ERC1155 Contract Address on the Chain
   * @returns any Default Response
   * @throws ApiError
   */
  getOwned(walletAddress, chain, contractAddress) {
    return this.httpRequest.request({
      method: 'GET',
      url: '/contract/{chain}/{contractAddress}/erc1155/get-owned',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      query: {
        'walletAddress': walletAddress
      },
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Get balance
   * Get the balance of a specific wallet address for this ERC-1155 contract.
   * @param walletAddress Address of the wallet to check NFT balance
   * @param tokenId The tokenId of the NFT to check balance of
   * @param chain Chain ID or name
   * @param contractAddress ERC1155 Contract Address on the Chain
   * @returns any Default Response
   * @throws ApiError
   */
  balanceOf(walletAddress, tokenId, chain, contractAddress) {
    return this.httpRequest.request({
      method: 'GET',
      url: '/contract/{chain}/{contractAddress}/erc1155/balance-of',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      query: {
        'walletAddress': walletAddress,
        'tokenId': tokenId
      },
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Check if approved transfers
   * Check if the specific wallet has approved transfers from a specific operator wallet.
   * @param ownerWallet Address of the wallet who owns the NFT
   * @param operator Address of the operator to check approval on
   * @param chain Chain ID or name
   * @param contractAddress ERC1155 Contract Address on the Chain
   * @returns any Default Response
   * @throws ApiError
   */
  isApproved(ownerWallet, operator, chain, contractAddress) {
    return this.httpRequest.request({
      method: 'GET',
      url: '/contract/{chain}/{contractAddress}/erc1155/is-approved',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      query: {
        'ownerWallet': ownerWallet,
        'operator': operator
      },
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Get total supply
   * Get the total supply in circulation for this ERC-1155 contract.
   * @param chain Chain ID or name
   * @param contractAddress ERC1155 Contract Address on the Chain
   * @returns any Default Response
   * @throws ApiError
   */
  totalCount(chain, contractAddress) {
    return this.httpRequest.request({
      method: 'GET',
      url: '/contract/{chain}/{contractAddress}/erc1155/total-count',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Get total supply
   * Get the total supply in circulation for this ERC-1155 contract.
   * @param tokenId The tokenId of the NFT to retrieve
   * @param chain Chain ID or name
   * @param contractAddress ERC1155 Contract Address on the Chain
   * @returns any Default Response
   * @throws ApiError
   */
  totalSupply(tokenId, chain, contractAddress) {
    return this.httpRequest.request({
      method: 'GET',
      url: '/contract/{chain}/{contractAddress}/erc1155/total-supply',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      query: {
        'tokenId': tokenId
      },
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Generate signature
   * Generate a signature granting access for another wallet to mint tokens from this ERC-721 contract. This method is typically called by the token contract owner.
   * @param chain Chain ID or name
   * @param contractAddress ERC721 Contract Address on the Chain
   * @param requestBody
   * @returns any Default Response
   * @throws ApiError
   */
  signatureGenerate(chain, contractAddress, requestBody) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/contract/{chain}/{contractAddress}/erc1155/signature/generate',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      body: requestBody,
      mediaType: 'application/json',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Airdrop tokens
   * Airdrop ERC-1155 tokens to specific wallets.
   * @param chain Chain ID or name
   * @param contractAddress ERC1155 Contract Address on the Chain
   * @param xBackendWalletAddress Backend wallet address
   * @param requestBody
   * @param xAccountAddress Smart account address
   * @returns any Default Response
   * @throws ApiError
   */
  airdrop(chain, contractAddress, xBackendWalletAddress, requestBody, xAccountAddress) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/contract/{chain}/{contractAddress}/erc1155/airdrop',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      headers: {
        'x-backend-wallet-address': xBackendWalletAddress,
        'x-account-address': xAccountAddress
      },
      body: requestBody,
      mediaType: 'application/json',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Burn token
   * Burn ERC-1155 tokens in the caller wallet.
   * @param chain Chain ID or name
   * @param contractAddress ERC1155 Contract Address on the Chain
   * @param xBackendWalletAddress Backend wallet address
   * @param requestBody
   * @param xAccountAddress Smart account address
   * @returns any Default Response
   * @throws ApiError
   */
  burn(chain, contractAddress, xBackendWalletAddress, requestBody, xAccountAddress) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/contract/{chain}/{contractAddress}/erc1155/burn',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      headers: {
        'x-backend-wallet-address': xBackendWalletAddress,
        'x-account-address': xAccountAddress
      },
      body: requestBody,
      mediaType: 'application/json',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Burn tokens (batch)
   * Burn a batch of ERC-1155 tokens in the caller wallet.
   * @param chain Chain ID or name
   * @param contractAddress ERC1155 Contract Address on the Chain
   * @param xBackendWalletAddress Backend wallet address
   * @param requestBody
   * @param xAccountAddress Smart account address
   * @returns any Default Response
   * @throws ApiError
   */
  burnBatch(chain, contractAddress, xBackendWalletAddress, requestBody, xAccountAddress) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/contract/{chain}/{contractAddress}/erc1155/burn-batch',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      headers: {
        'x-backend-wallet-address': xBackendWalletAddress,
        'x-account-address': xAccountAddress
      },
      body: requestBody,
      mediaType: 'application/json',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Claim tokens to wallet
   * Claim ERC-1155 tokens to a specific wallet.
   * @param chain Chain ID or name
   * @param contractAddress ERC1155 Contract Address on the Chain
   * @param xBackendWalletAddress Backend wallet address
   * @param requestBody
   * @param xAccountAddress Smart account address
   * @returns any Default Response
   * @throws ApiError
   */
  claimTo(chain, contractAddress, xBackendWalletAddress, requestBody, xAccountAddress) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/contract/{chain}/{contractAddress}/erc1155/claim-to',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      headers: {
        'x-backend-wallet-address': xBackendWalletAddress,
        'x-account-address': xAccountAddress
      },
      body: requestBody,
      mediaType: 'application/json',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Lazy mint
   * Lazy mint ERC-1155 tokens to be claimed in the future.
   * @param chain Chain ID or name
   * @param contractAddress ERC1155 Contract Address on the Chain
   * @param xBackendWalletAddress Backend wallet address
   * @param requestBody
   * @param xAccountAddress Smart account address
   * @returns any Default Response
   * @throws ApiError
   */
  lazyMint(chain, contractAddress, xBackendWalletAddress, requestBody, xAccountAddress) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/contract/{chain}/{contractAddress}/erc1155/lazy-mint',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      headers: {
        'x-backend-wallet-address': xBackendWalletAddress,
        'x-account-address': xAccountAddress
      },
      body: requestBody,
      mediaType: 'application/json',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Mint additional supply
   * Mint additional supply of ERC-1155 tokens to a specific wallet.
   * @param chain Chain ID or name
   * @param contractAddress ERC1155 Contract Address on the Chain
   * @param xBackendWalletAddress Backend wallet address
   * @param requestBody
   * @param xAccountAddress Smart account address
   * @returns any Default Response
   * @throws ApiError
   */
  mintAdditionalSupplyTo(chain, contractAddress, xBackendWalletAddress, requestBody, xAccountAddress) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/contract/{chain}:contractAddress/erc1155/mint-additional-supply-to',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      headers: {
        'x-backend-wallet-address': xBackendWalletAddress,
        'x-account-address': xAccountAddress
      },
      body: requestBody,
      mediaType: 'application/json',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Mint tokens (batch)
   * Mint ERC-1155 tokens to multiple wallets in one transaction.
   * @param chain Chain ID or name
   * @param contractAddress ERC1155 Contract Address on the Chain
   * @param xBackendWalletAddress Backend wallet address
   * @param requestBody
   * @param xAccountAddress Smart account address
   * @returns any Default Response
   * @throws ApiError
   */
  mintBatchTo(chain, contractAddress, xBackendWalletAddress, requestBody, xAccountAddress) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/contract/{chain}/{contractAddress}/erc1155/mint-batch-to',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      headers: {
        'x-backend-wallet-address': xBackendWalletAddress,
        'x-account-address': xAccountAddress
      },
      body: requestBody,
      mediaType: 'application/json',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Mint tokens
   * Mint ERC-1155 tokens to a specific wallet.
   * @param chain Chain ID or name
   * @param contractAddress ERC1155 Contract Address on the Chain
   * @param xBackendWalletAddress Backend wallet address
   * @param requestBody
   * @param xAccountAddress Smart account address
   * @returns any Default Response
   * @throws ApiError
   */
  mintTo(chain, contractAddress, xBackendWalletAddress, requestBody, xAccountAddress) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/contract/{chain}/{contractAddress}/erc1155/mint-to',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      headers: {
        'x-backend-wallet-address': xBackendWalletAddress,
        'x-account-address': xAccountAddress
      },
      body: requestBody,
      mediaType: 'application/json',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Set approval for all
   * Approve or remove operator as an operator for the caller. Operators can call transferFrom or safeTransferFrom for any token owned by the caller.
   * @param chain Chain ID or name
   * @param contractAddress ERC1155 Contract Address on the Chain
   * @param xBackendWalletAddress Backend wallet address
   * @param requestBody
   * @param xAccountAddress Smart account address
   * @returns any Default Response
   * @throws ApiError
   */
  setApprovalForAll(chain, contractAddress, xBackendWalletAddress, requestBody, xAccountAddress) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/contract/{chain}/{contractAddress}/erc1155/set-approval-for-all',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      headers: {
        'x-backend-wallet-address': xBackendWalletAddress,
        'x-account-address': xAccountAddress
      },
      body: requestBody,
      mediaType: 'application/json',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Transfer token
   * Transfer an ERC-1155 token from the caller wallet.
   * @param chain Chain ID or name
   * @param contractAddress ERC1155 Contract Address on the Chain
   * @param xBackendWalletAddress Backend wallet address
   * @param requestBody
   * @param xAccountAddress Smart account address
   * @returns any Default Response
   * @throws ApiError
   */
  transfer(chain, contractAddress, xBackendWalletAddress, requestBody, xAccountAddress) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/contract/{chain}/{contractAddress}/erc1155/transfer',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      headers: {
        'x-backend-wallet-address': xBackendWalletAddress,
        'x-account-address': xAccountAddress
      },
      body: requestBody,
      mediaType: 'application/json',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Transfer token from wallet
   * Transfer an ERC-1155 token from the connected wallet to another wallet. Requires allowance.
   * @param chain Chain ID or name
   * @param contractAddress ERC1155 Contract Address on the Chain
   * @param xBackendWalletAddress Backend wallet address
   * @param requestBody
   * @param xAccountAddress Smart account address
   * @returns any Default Response
   * @throws ApiError
   */
  transferFrom(chain, contractAddress, xBackendWalletAddress, requestBody, xAccountAddress) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/contract/{chain}/{contractAddress}/erc1155/transfer-from',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      headers: {
        'x-backend-wallet-address': xBackendWalletAddress,
        'x-account-address': xAccountAddress
      },
      body: requestBody,
      mediaType: 'application/json',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Signature mint
   * Mint ERC-1155 tokens from a generated signature.
   * @param chain Chain ID or name
   * @param contractAddress Contract address on the chain
   * @param xBackendWalletAddress Backend wallet address
   * @param requestBody
   * @param xAccountAddress Smart account address
   * @returns any Default Response
   * @throws ApiError
   */
  signatureMint(chain, contractAddress, xBackendWalletAddress, requestBody, xAccountAddress) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/contract/{chain}/{contractAddress}/erc1155/signature/mint',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      headers: {
        'x-backend-wallet-address': xBackendWalletAddress,
        'x-account-address': xAccountAddress
      },
      body: requestBody,
      mediaType: 'application/json',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }
}

/* generated using openapi-typescript-codegen -- do no edit */
/* istanbul ignore file */
/* tslint:disable */
/* eslint-disable */

class Erc20Service {
  constructor(httpRequest) {
    this.httpRequest = httpRequest;
  }

  /**
   * Get token allowance
   * Get the allowance of a specific wallet for an ERC-20 contract.
   * @param ownerWallet Address of the wallet who owns the funds
   * @param spenderWallet Address of the wallet to check token allowance
   * @param chain Chain ID or name
   * @param contractAddress ERC20 Contract Address on the Chain
   * @returns any Default Response
   * @throws ApiError
   */
  allowanceOf(ownerWallet, spenderWallet, chain, contractAddress) {
    return this.httpRequest.request({
      method: 'GET',
      url: '/contract/{chain}/{contractAddress}/erc20/allowance-of',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      query: {
        'ownerWallet': ownerWallet,
        'spenderWallet': spenderWallet
      },
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Get token balance
   * Get the balance of a specific wallet address for this ERC-20 contract.
   * @param walletAddress Address of the wallet to check token balance
   * @param chain Chain ID or name
   * @param contractAddress ERC20 Contract Address on the Chain
   * @returns any Default Response
   * @throws ApiError
   */
  balanceOf(walletAddress, chain, contractAddress) {
    return this.httpRequest.request({
      method: 'GET',
      url: '/contract/{chain}/{contractAddress}/erc20/balance-of',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      query: {
        'wallet_address': walletAddress
      },
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Get token details
   * Get details for this ERC-20 contract.
   * @param chain Chain ID or name
   * @param contractAddress ERC20 Contract Address on the Chain
   * @returns any Default Response
   * @throws ApiError
   */
  get(chain, contractAddress) {
    return this.httpRequest.request({
      method: 'GET',
      url: '/contract/{chain}/{contractAddress}/erc20/get',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Get total supply
   * Get the total supply in circulation for this ERC-20 contract.
   * @param chain Chain ID or name
   * @param contractAddress ERC20 Contract Address on the Chain
   * @returns any Default Response
   * @throws ApiError
   */
  totalSupply(chain, contractAddress) {
    return this.httpRequest.request({
      method: 'GET',
      url: '/contract/{chain}/{contractAddress}/erc20/total-supply',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Generate signature
   * Generate a signature granting access for another wallet to mint tokens from this ERC-20 contract. This method is typically called by the token contract owner.
   * @param chain Chain ID or name
   * @param contractAddress ERC721 Contract Address on the Chain
   * @param requestBody
   * @returns any Default Response
   * @throws ApiError
   */
  signatureGenerate(chain, contractAddress, requestBody) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/contract/{chain}/{contractAddress}/erc20/signature/generate',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      body: requestBody,
      mediaType: 'application/json',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Set allowance
   * Grant a specific wallet address to transfer ERC-20 tokens from the caller wallet.
   * @param chain Chain ID or name
   * @param contractAddress ERC20 Contract Address on the Chain
   * @param xBackendWalletAddress Backend wallet address
   * @param requestBody
   * @param xAccountAddress Smart account address
   * @returns any Default Response
   * @throws ApiError
   */
  setAllowance(chain, contractAddress, xBackendWalletAddress, requestBody, xAccountAddress) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/contract/{chain}/{contractAddress}/erc20/set-allowance',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      headers: {
        'x-backend-wallet-address': xBackendWalletAddress,
        'x-account-address': xAccountAddress
      },
      body: requestBody,
      mediaType: 'application/json',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Transfer tokens
   * Transfer ERC-20 tokens from the caller wallet to a specific wallet.
   * @param chain Chain ID or name
   * @param contractAddress ERC20 Contract Address on the Chain
   * @param xBackendWalletAddress Backend wallet address
   * @param requestBody
   * @param xAccountAddress Smart account address
   * @returns any Default Response
   * @throws ApiError
   */
  transfer(chain, contractAddress, xBackendWalletAddress, requestBody, xAccountAddress) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/contract/{chain}/{contractAddress}/erc20/transfer',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      headers: {
        'x-backend-wallet-address': xBackendWalletAddress,
        'x-account-address': xAccountAddress
      },
      body: requestBody,
      mediaType: 'application/json',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Transfer tokens from wallet
   * Transfer ERC-20 tokens from the connected wallet to another wallet. Requires allowance.
   * @param chain Chain ID or name
   * @param contractAddress ERC20 Contract Address on the Chain
   * @param xBackendWalletAddress Backend wallet address
   * @param requestBody
   * @param xAccountAddress Smart account address
   * @returns any Default Response
   * @throws ApiError
   */
  transferFrom(chain, contractAddress, xBackendWalletAddress, requestBody, xAccountAddress) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/contract/{chain}/{contractAddress}/erc20/transfer-from',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      headers: {
        'x-backend-wallet-address': xBackendWalletAddress,
        'x-account-address': xAccountAddress
      },
      body: requestBody,
      mediaType: 'application/json',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Burn token
   * Burn ERC-20 tokens in the caller wallet.
   * @param chain Chain ID or name
   * @param contractAddress ERC20 Contract Address on the Chain
   * @param xBackendWalletAddress Backend wallet address
   * @param requestBody
   * @param xAccountAddress Smart account address
   * @returns any Default Response
   * @throws ApiError
   */
  burn(chain, contractAddress, xBackendWalletAddress, requestBody, xAccountAddress) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/contract/{chain}/{contractAddress}/erc20/burn',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      headers: {
        'x-backend-wallet-address': xBackendWalletAddress,
        'x-account-address': xAccountAddress
      },
      body: requestBody,
      mediaType: 'application/json',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Burn token from wallet
   * Burn ERC-20 tokens in a specific wallet. Requires allowance.
   * @param chain Chain ID or name
   * @param contractAddress ERC20 Contract Address on the Chain
   * @param xBackendWalletAddress Backend wallet address
   * @param requestBody
   * @param xAccountAddress Smart account address
   * @returns any Default Response
   * @throws ApiError
   */
  burnFrom(chain, contractAddress, xBackendWalletAddress, requestBody, xAccountAddress) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/contract/{chain}/{contractAddress}/erc20/burn-from',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      headers: {
        'x-backend-wallet-address': xBackendWalletAddress,
        'x-account-address': xAccountAddress
      },
      body: requestBody,
      mediaType: 'application/json',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Claim tokens to wallet
   * Claim ERC-20 tokens to a specific wallet.
   * @param chain Chain ID or name
   * @param contractAddress ERC20 Contract Address on the Chain
   * @param xBackendWalletAddress Backend wallet address
   * @param requestBody
   * @param xAccountAddress Smart account address
   * @returns any Default Response
   * @throws ApiError
   */
  claimTo(chain, contractAddress, xBackendWalletAddress, requestBody, xAccountAddress) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/contract/{chain}/{contractAddress}/erc20/claim-to',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      headers: {
        'x-backend-wallet-address': xBackendWalletAddress,
        'x-account-address': xAccountAddress
      },
      body: requestBody,
      mediaType: 'application/json',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Mint tokens (batch)
   * Mint ERC-20 tokens to multiple wallets in one transaction.
   * @param chain Chain ID or name
   * @param contractAddress ERC20 Contract Address on the Chain
   * @param xBackendWalletAddress Backend wallet address
   * @param requestBody
   * @param xAccountAddress Smart account address
   * @returns any Default Response
   * @throws ApiError
   */
  mintBatchTo(chain, contractAddress, xBackendWalletAddress, requestBody, xAccountAddress) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/contract/{chain}/{contractAddress}/erc20/mint-batch-to',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      headers: {
        'x-backend-wallet-address': xBackendWalletAddress,
        'x-account-address': xAccountAddress
      },
      body: requestBody,
      mediaType: 'application/json',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Mint tokens
   * Mint ERC-20 tokens to a specific wallet.
   * @param chain Chain ID or name
   * @param contractAddress ERC20 Contract Address on the Chain
   * @param xBackendWalletAddress Backend wallet address
   * @param requestBody
   * @param xAccountAddress Smart account address
   * @returns any Default Response
   * @throws ApiError
   */
  mintTo(chain, contractAddress, xBackendWalletAddress, requestBody, xAccountAddress) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/contract/{chain}/{contractAddress}/erc20/mint-to',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      headers: {
        'x-backend-wallet-address': xBackendWalletAddress,
        'x-account-address': xAccountAddress
      },
      body: requestBody,
      mediaType: 'application/json',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Signature mint
   * Mint ERC-20 tokens from a generated signature.
   * @param chain Chain ID or name
   * @param contractAddress Contract address on the chain
   * @param xBackendWalletAddress Backend wallet address
   * @param requestBody
   * @param xAccountAddress Smart account address
   * @returns any Default Response
   * @throws ApiError
   */
  signatureMint(chain, contractAddress, xBackendWalletAddress, requestBody, xAccountAddress) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/contract/{chain}/{contractAddress}/erc20/signature/mint',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      headers: {
        'x-backend-wallet-address': xBackendWalletAddress,
        'x-account-address': xAccountAddress
      },
      body: requestBody,
      mediaType: 'application/json',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }
}

/* generated using openapi-typescript-codegen -- do no edit */
/* istanbul ignore file */
/* tslint:disable */
/* eslint-disable */

class Erc721Service {
  constructor(httpRequest) {
    this.httpRequest = httpRequest;
  }

  /**
   * Get details
   * Get the details for a token in an ERC-721 contract.
   * @param tokenId The tokenId of the NFT to retrieve
   * @param chain Chain ID or name
   * @param contractAddress Contract address on the chain
   * @returns any Default Response
   * @throws ApiError
   */
  get(tokenId, chain, contractAddress) {
    return this.httpRequest.request({
      method: 'GET',
      url: '/contract/{chain}/{contractAddress}/erc721/get',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      query: {
        'tokenId': tokenId
      },
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Get all details
   * Get details for all tokens in an ERC-721 contract.
   * @param chain Chain ID or name
   * @param contractAddress Contract address on the chain
   * @param start The start token id for paginated results. Defaults to 0.
   * @param count The page count for paginated results. Defaults to 100.
   * @returns any Default Response
   * @throws ApiError
   */
  getAll(chain, contractAddress, start, count) {
    return this.httpRequest.request({
      method: 'GET',
      url: '/contract/{chain}/{contractAddress}/erc721/get-all',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      query: {
        'start': start,
        'count': count
      },
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Get owned tokens
   * Get all tokens in an ERC-721 contract owned by a specific wallet.
   * @param walletAddress Address of the wallet to get NFTs for
   * @param chain Chain ID or name
   * @param contractAddress Contract address on the chain
   * @returns any Default Response
   * @throws ApiError
   */
  getOwned(walletAddress, chain, contractAddress) {
    return this.httpRequest.request({
      method: 'GET',
      url: '/contract/{chain}/{contractAddress}/erc721/get-owned',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      query: {
        'walletAddress': walletAddress
      },
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Get token balance
   * Get the balance of a specific wallet address for this ERC-721 contract.
   * @param walletAddress Address of the wallet to check NFT balance
   * @param chain Chain ID or name
   * @param contractAddress ERC721 Contract Address on the Chain
   * @returns any Default Response
   * @throws ApiError
   */
  balanceOf(walletAddress, chain, contractAddress) {
    return this.httpRequest.request({
      method: 'GET',
      url: '/contract/{chain}/{contractAddress}/erc721/balance-of',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      query: {
        'walletAddress': walletAddress
      },
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Check if approved transfers
   * Check if the specific wallet has approved transfers from a specific operator wallet.
   * @param ownerWallet Address of the wallet who owns the NFT
   * @param operator Address of the operator to check approval on
   * @param chain Chain ID or name
   * @param contractAddress Contract address on the chain
   * @returns any Default Response
   * @throws ApiError
   */
  isApproved(ownerWallet, operator, chain, contractAddress) {
    return this.httpRequest.request({
      method: 'GET',
      url: '/contract/{chain}/{contractAddress}/erc721/is-approved',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      query: {
        'ownerWallet': ownerWallet,
        'operator': operator
      },
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Get total supply
   * Get the total supply in circulation for this ERC-721 contract.
   * @param chain Chain ID or name
   * @param contractAddress Contract address on the chain
   * @returns any Default Response
   * @throws ApiError
   */
  totalCount(chain, contractAddress) {
    return this.httpRequest.request({
      method: 'GET',
      url: '/contract/{chain}/{contractAddress}/erc721/total-count',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Get claimed supply
   * Get the claimed supply for this ERC-721 contract.
   * @param chain Chain ID or name
   * @param contractAddress Contract address on the chain
   * @returns any Default Response
   * @throws ApiError
   */
  totalClaimedSupply(chain, contractAddress) {
    return this.httpRequest.request({
      method: 'GET',
      url: '/contract/{chain}/{contractAddress}/erc721/total-claimed-supply',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Get unclaimed supply
   * Get the unclaimed supply for this ERC-721 contract.
   * @param chain Chain ID or name
   * @param contractAddress Contract address on the chain
   * @returns any Default Response
   * @throws ApiError
   */
  totalUnclaimedSupply(chain, contractAddress) {
    return this.httpRequest.request({
      method: 'GET',
      url: '/contract/{chain}/{contractAddress}/erc721/total-unclaimed-supply',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Set approval for all
   * Approve or remove operator as an operator for the caller. Operators can call transferFrom or safeTransferFrom for any token owned by the caller.
   * @param chain Chain ID or name
   * @param contractAddress Contract address on the chain
   * @param xBackendWalletAddress Backend wallet address
   * @param requestBody
   * @param xAccountAddress Smart account address
   * @returns any Default Response
   * @throws ApiError
   */
  setApprovalForAll(chain, contractAddress, xBackendWalletAddress, requestBody, xAccountAddress) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/contract/{chain}/{contractAddress}/erc721/set-approval-for-all',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      headers: {
        'x-backend-wallet-address': xBackendWalletAddress,
        'x-account-address': xAccountAddress
      },
      body: requestBody,
      mediaType: 'application/json',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Set approval for token
   * Approve an operator for the NFT owner. Operators can call transferFrom or safeTransferFrom for the specific token.
   * @param chain Chain ID or name
   * @param contractAddress Contract address on the chain
   * @param xBackendWalletAddress Backend wallet address
   * @param requestBody
   * @param xAccountAddress Smart account address
   * @returns any Default Response
   * @throws ApiError
   */
  setApprovalForToken(chain, contractAddress, xBackendWalletAddress, requestBody, xAccountAddress) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/contract/{chain}/{contractAddress}/erc721/set-approval-for-token',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      headers: {
        'x-backend-wallet-address': xBackendWalletAddress,
        'x-account-address': xAccountAddress
      },
      body: requestBody,
      mediaType: 'application/json',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Transfer token
   * Transfer an ERC-721 token from the caller wallet.
   * @param chain Chain ID or name
   * @param contractAddress Contract address on the chain
   * @param xBackendWalletAddress Backend wallet address
   * @param requestBody
   * @param xAccountAddress Smart account address
   * @returns any Default Response
   * @throws ApiError
   */
  transfer(chain, contractAddress, xBackendWalletAddress, requestBody, xAccountAddress) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/contract/{chain}/{contractAddress}/erc721/transfer',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      headers: {
        'x-backend-wallet-address': xBackendWalletAddress,
        'x-account-address': xAccountAddress
      },
      body: requestBody,
      mediaType: 'application/json',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Transfer token from wallet
   * Transfer an ERC-721 token from the connected wallet to another wallet. Requires allowance.
   * @param chain Chain ID or name
   * @param contractAddress Contract address on the chain
   * @param xBackendWalletAddress Backend wallet address
   * @param requestBody
   * @param xAccountAddress Smart account address
   * @returns any Default Response
   * @throws ApiError
   */
  transferFrom(chain, contractAddress, xBackendWalletAddress, requestBody, xAccountAddress) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/contract/{chain}/{contractAddress}/erc721/transfer-from',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      headers: {
        'x-backend-wallet-address': xBackendWalletAddress,
        'x-account-address': xAccountAddress
      },
      body: requestBody,
      mediaType: 'application/json',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Mint tokens
   * Mint ERC-721 tokens to a specific wallet.
   * @param chain Chain ID or name
   * @param contractAddress Contract address on the chain
   * @param xBackendWalletAddress Backend wallet address
   * @param requestBody
   * @param xAccountAddress Smart account address
   * @returns any Default Response
   * @throws ApiError
   */
  mintTo(chain, contractAddress, xBackendWalletAddress, requestBody, xAccountAddress) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/contract/{chain}/{contractAddress}/erc721/mint-to',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      headers: {
        'x-backend-wallet-address': xBackendWalletAddress,
        'x-account-address': xAccountAddress
      },
      body: requestBody,
      mediaType: 'application/json',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Mint tokens (batch)
   * Mint ERC-721 tokens to multiple wallets in one transaction.
   * @param chain Chain ID or name
   * @param contractAddress Contract address on the chain
   * @param xBackendWalletAddress Backend wallet address
   * @param requestBody
   * @param xAccountAddress Smart account address
   * @returns any Default Response
   * @throws ApiError
   */
  mintBatchTo(chain, contractAddress, xBackendWalletAddress, requestBody, xAccountAddress) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/contract/{chain}/{contractAddress}/erc721/mint-batch-to',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      headers: {
        'x-backend-wallet-address': xBackendWalletAddress,
        'x-account-address': xAccountAddress
      },
      body: requestBody,
      mediaType: 'application/json',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Burn token
   * Burn ERC-721 tokens in the caller wallet.
   * @param chain Chain ID or name
   * @param contractAddress Contract address on the chain
   * @param xBackendWalletAddress Backend wallet address
   * @param requestBody
   * @param xAccountAddress Smart account address
   * @returns any Default Response
   * @throws ApiError
   */
  burn(chain, contractAddress, xBackendWalletAddress, requestBody, xAccountAddress) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/contract/{chain}/{contractAddress}/erc721/burn',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      headers: {
        'x-backend-wallet-address': xBackendWalletAddress,
        'x-account-address': xAccountAddress
      },
      body: requestBody,
      mediaType: 'application/json',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Lazy mint
   * Lazy mint ERC-721 tokens to be claimed in the future.
   * @param chain Chain ID or name
   * @param contractAddress Contract address on the chain
   * @param xBackendWalletAddress Backend wallet address
   * @param requestBody
   * @param xAccountAddress Smart account address
   * @returns any Default Response
   * @throws ApiError
   */
  lazyMint(chain, contractAddress, xBackendWalletAddress, requestBody, xAccountAddress) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/contract/{chain}/{contractAddress}/erc721/lazy-mint',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      headers: {
        'x-backend-wallet-address': xBackendWalletAddress,
        'x-account-address': xAccountAddress
      },
      body: requestBody,
      mediaType: 'application/json',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Claim tokens to wallet
   * Claim ERC-721 tokens to a specific wallet.
   * @param chain Chain ID or name
   * @param contractAddress Contract address on the chain
   * @param xBackendWalletAddress Backend wallet address
   * @param requestBody
   * @param xAccountAddress Smart account address
   * @returns any Default Response
   * @throws ApiError
   */
  claimTo(chain, contractAddress, xBackendWalletAddress, requestBody, xAccountAddress) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/contract/{chain}/{contractAddress}/erc721/claim-to',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      headers: {
        'x-backend-wallet-address': xBackendWalletAddress,
        'x-account-address': xAccountAddress
      },
      body: requestBody,
      mediaType: 'application/json',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Generate signature
   * Generate a signature granting access for another wallet to mint tokens from this ERC-721 contract. This method is typically called by the token contract owner.
   * @param chain Chain ID or name
   * @param contractAddress ERC721 Contract Address on the Chain
   * @param xBackendWalletAddress Backend wallet address
   * @param requestBody
   * @param xAccountAddress Smart account address
   * @returns any Default Response
   * @throws ApiError
   */
  signatureGenerate(chain, contractAddress, xBackendWalletAddress, requestBody, xAccountAddress) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/contract/{chain}/{contractAddress}/erc721/signature/generate',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      headers: {
        'x-backend-wallet-address': xBackendWalletAddress,
        'x-account-address': xAccountAddress
      },
      body: requestBody,
      mediaType: 'application/json',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Signature mint
   * Mint ERC-721 tokens from a generated signature.
   * @param chain Chain ID or name
   * @param contractAddress Contract address on the chain
   * @param xBackendWalletAddress Backend wallet address
   * @param requestBody
   * @param xAccountAddress Smart account address
   * @returns any Default Response
   * @throws ApiError
   */
  signatureMint(chain, contractAddress, xBackendWalletAddress, requestBody, xAccountAddress) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/contract/{chain}/{contractAddress}/erc721/signature/mint',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      headers: {
        'x-backend-wallet-address': xBackendWalletAddress,
        'x-account-address': xAccountAddress
      },
      body: requestBody,
      mediaType: 'application/json',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }
}

/* generated using openapi-typescript-codegen -- do no edit */
/* istanbul ignore file */
/* tslint:disable */
/* eslint-disable */

class MarketplaceDirectListingsService {
  constructor(httpRequest) {
    this.httpRequest = httpRequest;
  }

  /**
   * Get all listings
   * Get all direct listings for this marketplace contract.
   * @param chain Chain ID or name
   * @param contractAddress Contract Address on the Chain
   * @param count Number of listings to fetch
   * @param seller Being sold by this Address
   * @param start Satrt from this index (pagination)
   * @param tokenContract Token contract address to show NFTs from
   * @param tokenId Only show NFTs with this ID
   * @returns any Default Response
   * @throws ApiError
   */
  getAll(chain, contractAddress, count, seller, start, tokenContract, tokenId) {
    return this.httpRequest.request({
      method: 'GET',
      url: '/marketplace/{chain}/{contractAddress}/direct-listings/get-all',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      query: {
        'count': count,
        'seller': seller,
        'start': start,
        'tokenContract': tokenContract,
        'tokenId': tokenId
      },
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Get all valid listings
   * Get all the valid direct listings for this marketplace contract. A valid listing is where the listing is active, and the creator still owns & has approved Marketplace to transfer the listed NFTs.
   * @param chain Chain ID or name
   * @param contractAddress Contract Address on the Chain
   * @param count Number of listings to fetch
   * @param seller Being sold by this Address
   * @param start Satrt from this index (pagination)
   * @param tokenContract Token contract address to show NFTs from
   * @param tokenId Only show NFTs with this ID
   * @returns any Default Response
   * @throws ApiError
   */
  getAllValid(chain, contractAddress, count, seller, start, tokenContract, tokenId) {
    return this.httpRequest.request({
      method: 'GET',
      url: '/marketplace/{chain}/{contractAddress}/direct-listings/get-all-valid',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      query: {
        'count': count,
        'seller': seller,
        'start': start,
        'tokenContract': tokenContract,
        'tokenId': tokenId
      },
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Get direct listing
   * Gets a direct listing on this marketplace contract.
   * @param listingId The id of the listing to retrieve.
   * @param chain Chain ID or name
   * @param contractAddress Contract Address on the Chain
   * @returns any Default Response
   * @throws ApiError
   */
  getListing(listingId, chain, contractAddress) {
    return this.httpRequest.request({
      method: 'GET',
      url: '/marketplace/{chain}/{contractAddress}/direct-listings/get-listing',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      query: {
        'listingId': listingId
      },
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Check approved buyer
   * Check if a buyer is approved to purchase a specific direct listing.
   * @param listingId The id of the listing to retrieve.
   * @param walletAddress The wallet address of the buyer to check.
   * @param chain Chain ID or name
   * @param contractAddress Contract Address on the Chain
   * @param xBackendWalletAddress Backend wallet address
   * @param xAccountAddress Smart account address
   * @returns any Default Response
   * @throws ApiError
   */
  isBuyerApprovedForListing(listingId, walletAddress, chain, contractAddress, xBackendWalletAddress, xAccountAddress) {
    return this.httpRequest.request({
      method: 'GET',
      url: '/marketplace/{chain}/{contractAddress}/direct-listings/is-buyer-approved-for-listing',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      headers: {
        'x-backend-wallet-address': xBackendWalletAddress,
        'x-account-address': xAccountAddress
      },
      query: {
        'listingId': listingId,
        'walletAddress': walletAddress
      },
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Check approved currency
   * Check if a currency is approved for a specific direct listing.
   * @param listingId The id of the listing to retrieve.
   * @param currencyContractAddress The smart contract address of the ERC20 token to check.
   * @param chain Chain ID or name
   * @param contractAddress Contract Address on the Chain
   * @returns any Default Response
   * @throws ApiError
   */
  isCurrencyApprovedForListing(listingId, currencyContractAddress, chain, contractAddress) {
    return this.httpRequest.request({
      method: 'GET',
      url: '/marketplace/{chain}/{contractAddress}/direct-listings/is-currency-approved-for-listing',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      query: {
        'listingId': listingId,
        'currencyContractAddress': currencyContractAddress
      },
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Transfer token from wallet
   * Get the total number of direct listings on this marketplace contract.
   * @param chain Chain ID or name
   * @param contractAddress Contract Address on the Chain
   * @returns any Default Response
   * @throws ApiError
   */
  getTotalCount(chain, contractAddress) {
    return this.httpRequest.request({
      method: 'GET',
      url: '/marketplace/{chain}/{contractAddress}/direct-listings/get-total-count',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Create direct listing
   * Create a direct listing on this marketplace contract.
   * @param chain Chain ID or name
   * @param contractAddress Contract Address on the Chain
   * @param xBackendWalletAddress Backend wallet address
   * @param requestBody
   * @param xAccountAddress Smart account address
   * @returns any Default Response
   * @throws ApiError
   */
  createListing(chain, contractAddress, xBackendWalletAddress, requestBody, xAccountAddress) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/marketplace/{chain}/{contractAddress}/direct-listings/create-listing',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      headers: {
        'x-backend-wallet-address': xBackendWalletAddress,
        'x-account-address': xAccountAddress
      },
      body: requestBody,
      mediaType: 'application/json',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Update direct listing
   * Update a direct listing on this marketplace contract.
   * @param chain Chain ID or name
   * @param contractAddress Contract Address on the Chain
   * @param xBackendWalletAddress Backend wallet address
   * @param xAccountAddress Smart account address
   * @param requestBody
   * @returns any Default Response
   * @throws ApiError
   */
  updateListing(chain, contractAddress, xBackendWalletAddress, xAccountAddress, requestBody) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/marketplace/{chain}/{contractAddress}/direct-listings/update-listing',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      headers: {
        'x-backend-wallet-address': xBackendWalletAddress,
        'x-account-address': xAccountAddress
      },
      body: requestBody,
      mediaType: 'application/json',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Buy from direct listing
   * Buy from a specific direct listing from this marketplace contract.
   * @param chain Chain ID or name
   * @param contractAddress Contract Address on the Chain
   * @param xBackendWalletAddress Backend wallet address
   * @param requestBody
   * @param xAccountAddress Smart account address
   * @returns any Default Response
   * @throws ApiError
   */
  buyFromListing(chain, contractAddress, xBackendWalletAddress, requestBody, xAccountAddress) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/marketplace/{chain}/{contractAddress}/direct-listings/buy-from-listing',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      headers: {
        'x-backend-wallet-address': xBackendWalletAddress,
        'x-account-address': xAccountAddress
      },
      body: requestBody,
      mediaType: 'application/json',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Approve buyer for reserved listing
   * Approve a wallet address to buy from a reserved listing.
   * @param chain Chain ID or name
   * @param contractAddress Contract Address on the Chain
   * @param xBackendWalletAddress Backend wallet address
   * @param requestBody
   * @param xAccountAddress Smart account address
   * @returns any Default Response
   * @throws ApiError
   */
  approveBuyerForReservedListing(chain, contractAddress, xBackendWalletAddress, requestBody, xAccountAddress) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/marketplace/{chain}/{contractAddress}/direct-listings/approve-buyer-for-reserved-listing',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      headers: {
        'x-backend-wallet-address': xBackendWalletAddress,
        'x-account-address': xAccountAddress
      },
      body: requestBody,
      mediaType: 'application/json',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Revoke approval for reserved listings
   * Revoke approval for a buyer to purchase a reserved listing.
   * @param chain Chain ID or name
   * @param contractAddress Contract Address on the Chain
   * @param xBackendWalletAddress Backend wallet address
   * @param requestBody
   * @param xAccountAddress Smart account address
   * @returns any Default Response
   * @throws ApiError
   */
  revokeBuyerApprovalForReservedListing(chain, contractAddress, xBackendWalletAddress, requestBody, xAccountAddress) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/marketplace/{chain}/{contractAddress}/direct-listings/revoke-buyer-approval-for-reserved-listing',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      headers: {
        'x-backend-wallet-address': xBackendWalletAddress,
        'x-account-address': xAccountAddress
      },
      body: requestBody,
      mediaType: 'application/json',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Revoke currency approval for reserved listing
   * Revoke approval of a currency for a reserved listing.
   * @param chain Chain ID or name
   * @param contractAddress Contract Address on the Chain
   * @param xBackendWalletAddress Backend wallet address
   * @param requestBody
   * @param xAccountAddress Smart account address
   * @returns any Default Response
   * @throws ApiError
   */
  revokeCurrencyApprovalForListing(chain, contractAddress, xBackendWalletAddress, requestBody, xAccountAddress) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/marketplace/{chain}/{contractAddress}/direct-listings/revoke-currency-approval-for-listing',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      headers: {
        'x-backend-wallet-address': xBackendWalletAddress,
        'x-account-address': xAccountAddress
      },
      body: requestBody,
      mediaType: 'application/json',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }
}

/* generated using openapi-typescript-codegen -- do no edit */
/* istanbul ignore file */
/* tslint:disable */
/* eslint-disable */

class MarketplaceEnglishAuctionsService {
  constructor(httpRequest) {
    this.httpRequest = httpRequest;
  }

  /**
   * Get all English auctions
   * Get all English auction listings on this marketplace contract.
   * @param chain Chain ID or name
   * @param contractAddress Contract Address on the Chain
   * @param count Number of listings to fetch
   * @param seller Being sold by this Address
   * @param start Satrt from this index (pagination)
   * @param tokenContract Token contract address to show NFTs from
   * @param tokenId Only show NFTs with this ID
   * @returns any Default Response
   * @throws ApiError
   */
  getAll(chain, contractAddress, count, seller, start, tokenContract, tokenId) {
    return this.httpRequest.request({
      method: 'GET',
      url: '/marketplace/{chain}/{contractAddress}/english-auctions/get-all',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      query: {
        'count': count,
        'seller': seller,
        'start': start,
        'tokenContract': tokenContract,
        'tokenId': tokenId
      },
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Get all valid English auctions
   * Get all valid English auction listings on this marketplace contract.
   * @param chain Chain ID or name
   * @param contractAddress Contract Address on the Chain
   * @param count Number of listings to fetch
   * @param seller Being sold by this Address
   * @param start Satrt from this index (pagination)
   * @param tokenContract Token contract address to show NFTs from
   * @param tokenId Only show NFTs with this ID
   * @returns any Default Response
   * @throws ApiError
   */
  getAllValid(chain, contractAddress, count, seller, start, tokenContract, tokenId) {
    return this.httpRequest.request({
      method: 'GET',
      url: '/marketplace/{chain}/{contractAddress}/english-auctions/get-all-valid',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      query: {
        'count': count,
        'seller': seller,
        'start': start,
        'tokenContract': tokenContract,
        'tokenId': tokenId
      },
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Get English auction
   * Get a specific English auction listing on this marketplace contract.
   * @param listingId The id of the listing to retrieve.
   * @param chain Chain ID or name
   * @param contractAddress Contract Address on the Chain
   * @returns any Default Response
   * @throws ApiError
   */
  getAuction(listingId, chain, contractAddress) {
    return this.httpRequest.request({
      method: 'GET',
      url: '/marketplace/{chain}/{contractAddress}/english-auctions/get-auction',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      query: {
        'listingId': listingId
      },
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Get bid buffer BPS
   * Get the basis points of the bid buffer.
   * This is the percentage higher that a new bid must be than the current highest bid in order to be placed.
   * If there is no current bid, the bid must be at least the minimum bid amount.
   * Returns the value in percentage format, e.g. 100 = 1%.
   * @param listingId The id of the listing to retrieve.
   * @param chain Chain ID or name
   * @param contractAddress Contract Address on the Chain
   * @returns any Default Response
   * @throws ApiError
   */
  getBidBufferBps(listingId, chain, contractAddress) {
    return this.httpRequest.request({
      method: 'GET',
      url: '/marketplace/{chain}/{contractAddress}/english-auctions/get-bid-buffer-bps',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      query: {
        'listingId': listingId
      },
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Get minimum next bid
   * Helper function to calculate the value that the next bid must be in order to be accepted.
   * If there is no current bid, the bid must be at least the minimum bid amount.
   * If there is a current bid, the bid must be at least the current bid amount + the bid buffer.
   * @param listingId The id of the listing to retrieve.
   * @param chain Chain ID or name
   * @param contractAddress Contract Address on the Chain
   * @returns any Default Response
   * @throws ApiError
   */
  getMinimumNextBid(listingId, chain, contractAddress) {
    return this.httpRequest.request({
      method: 'GET',
      url: '/marketplace/{chain}/{contractAddress}/english-auctions/get-minimum-next-bid',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      query: {
        'listingId': listingId
      },
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Get winning bid
   * Get the current highest bid of an active auction.
   * @param listingId The ID of the listing to retrieve the winner for.
   * @param chain Chain ID or name
   * @param contractAddress Contract Address on the Chain
   * @returns any Default Response
   * @throws ApiError
   */
  getWinningBid(listingId, chain, contractAddress) {
    return this.httpRequest.request({
      method: 'GET',
      url: '/marketplace/{chain}/{contractAddress}/english-auctions/get-winning-bid',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      query: {
        'listingId': listingId
      },
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Get total listings
   * Get the count of English auction listings on this marketplace contract.
   * @param chain Chain ID or name
   * @param contractAddress Contract Address on the Chain
   * @returns any Default Response
   * @throws ApiError
   */
  getTotalCount(chain, contractAddress) {
    return this.httpRequest.request({
      method: 'GET',
      url: '/marketplace/{chain}/{contractAddress}/english-auctions/get-total-count',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Check winning bid
   * Check if a bid is or will be the winning bid for an auction.
   * @param listingId The ID of the listing to retrieve the winner for.
   * @param bidAmount The amount of the bid to check if it is the winning bid.
   * @param chain Chain ID or name
   * @param contractAddress Contract Address on the Chain
   * @returns any Default Response
   * @throws ApiError
   */
  isWinningBid(listingId, bidAmount, chain, contractAddress) {
    return this.httpRequest.request({
      method: 'GET',
      url: '/marketplace/{chain}/{contractAddress}/english-auctions/is-winning-bid',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      query: {
        'listingId': listingId,
        'bidAmount': bidAmount
      },
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Get winner
   * Get the winner of an English auction. Can only be called after the auction has ended.
   * @param listingId The ID of the listing to retrieve the winner for.
   * @param chain Chain ID or name
   * @param contractAddress Contract Address on the Chain
   * @returns any Default Response
   * @throws ApiError
   */
  getWinner(listingId, chain, contractAddress) {
    return this.httpRequest.request({
      method: 'GET',
      url: '/marketplace/{chain}/{contractAddress}/english-auctions/get-winner',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      query: {
        'listingId': listingId
      },
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Buyout English auction
   * Buyout the listing for this auction.
   * @param chain Chain ID or name
   * @param contractAddress Contract Address on the Chain
   * @param requestBody
   * @returns any Default Response
   * @throws ApiError
   */
  buyoutAuction(chain, contractAddress, requestBody) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/marketplace/{chain}/{contractAddress}/english-auctions/buyout-auction',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      body: requestBody,
      mediaType: 'application/json',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Cancel English auction
   * Cancel an existing auction listing. Only the creator of the listing can cancel it. Auctions cannot be canceled once a bid has been made.
   * @param chain Chain ID or name
   * @param contractAddress Contract Address on the Chain
   * @param requestBody
   * @returns any Default Response
   * @throws ApiError
   */
  cancelAuction(chain, contractAddress, requestBody) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/marketplace/{chain}/{contractAddress}/english-auctions/cancel-auction',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      body: requestBody,
      mediaType: 'application/json',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Create English auction
   * Create an English auction listing on this marketplace contract.
   * @param chain Chain ID or name
   * @param contractAddress Contract Address on the Chain
   * @param requestBody
   * @returns any Default Response
   * @throws ApiError
   */
  createAuction(chain, contractAddress, requestBody) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/marketplace/{chain}/{contractAddress}/english-auctions/create-auction',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      body: requestBody,
      mediaType: 'application/json',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Close English auction for bidder
   * After an auction has concluded (and a buyout did not occur),
   * execute the sale for the buyer, meaning the buyer receives the NFT(s).
   * You must also call closeAuctionForSeller to execute the sale for the seller,
   * meaning the seller receives the payment from the highest bid.
   * @param chain Chain ID or name
   * @param contractAddress Contract Address on the Chain
   * @param requestBody
   * @returns any Default Response
   * @throws ApiError
   */
  closeAuctionForBidder(chain, contractAddress, requestBody) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/marketplace/{chain}/{contractAddress}/english-auctions/close-auction-for-bidder',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      body: requestBody,
      mediaType: 'application/json',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Close English auction for seller
   * After an auction has concluded (and a buyout did not occur),
   * execute the sale for the seller, meaning the seller receives the payment from the highest bid.
   * You must also call closeAuctionForBidder to execute the sale for the buyer, meaning the buyer receives the NFT(s).
   * @param chain Chain ID or name
   * @param contractAddress Contract Address on the Chain
   * @param requestBody
   * @returns any Default Response
   * @throws ApiError
   */
  closeAuctionForSeller(chain, contractAddress, requestBody) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/marketplace/{chain}/{contractAddress}/english-auctions/close-auction-for-seller',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      body: requestBody,
      mediaType: 'application/json',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Execute sale
   * Close the auction for both buyer and seller.
   * This means the NFT(s) will be transferred to the buyer and the seller will receive the funds.
   * This function can only be called after the auction has ended.
   * @param chain Chain ID or name
   * @param contractAddress Contract Address on the Chain
   * @param requestBody
   * @returns any Default Response
   * @throws ApiError
   */
  executeSale(chain, contractAddress, requestBody) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/marketplace/{chain}/{contractAddress}/english-auctions/execute-sale',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      body: requestBody,
      mediaType: 'application/json',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Make bid
   * Place a bid on an English auction listing.
   * @param chain Chain ID or name
   * @param contractAddress Contract Address on the Chain
   * @param requestBody
   * @returns any Default Response
   * @throws ApiError
   */
  makeBid(chain, contractAddress, requestBody) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/marketplace/{chain}/{contractAddress}/english-auctions/make-bid',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      body: requestBody,
      mediaType: 'application/json',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }
}

/* generated using openapi-typescript-codegen -- do no edit */
/* istanbul ignore file */
/* tslint:disable */
/* eslint-disable */

class MarketplaceOffersService {
  constructor(httpRequest) {
    this.httpRequest = httpRequest;
  }

  /**
   * Get all offers
   * Get all offers on this marketplace contract.
   * @param chain Chain ID or name
   * @param contractAddress Contract Address on the Chain
   * @param count Number of listings to fetch
   * @param offeror has offers from this Address
   * @param start Satrt from this index (pagination)
   * @param tokenContract Token contract address to show NFTs from
   * @param tokenId Only show NFTs with this ID
   * @returns any Default Response
   * @throws ApiError
   */
  getAll(chain, contractAddress, count, offeror, start, tokenContract, tokenId) {
    return this.httpRequest.request({
      method: 'GET',
      url: '/marketplace/{chain}/{contractAddress}/offers/get-all',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      query: {
        'count': count,
        'offeror': offeror,
        'start': start,
        'tokenContract': tokenContract,
        'tokenId': tokenId
      },
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Get all valid offers
   * Get all valid offers on this marketplace contract. Valid offers are offers that have not expired, been canceled, or been accepted.
   * @param chain Chain ID or name
   * @param contractAddress Contract Address on the Chain
   * @param count Number of listings to fetch
   * @param offeror has offers from this Address
   * @param start Satrt from this index (pagination)
   * @param tokenContract Token contract address to show NFTs from
   * @param tokenId Only show NFTs with this ID
   * @returns any Default Response
   * @throws ApiError
   */
  getAllValid(chain, contractAddress, count, offeror, start, tokenContract, tokenId) {
    return this.httpRequest.request({
      method: 'GET',
      url: '/marketplace/{chain}/{contractAddress}/offers/get-all-valid',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      query: {
        'count': count,
        'offeror': offeror,
        'start': start,
        'tokenContract': tokenContract,
        'tokenId': tokenId
      },
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Get offer
   * Get details about an offer.
   * @param offerId The ID of the offer to get information about.
   * @param chain Chain ID or name
   * @param contractAddress Contract Address on the Chain
   * @returns any Default Response
   * @throws ApiError
   */
  getOffer(offerId, chain, contractAddress) {
    return this.httpRequest.request({
      method: 'GET',
      url: '/marketplace/{chain}/{contractAddress}/offers/get-offer',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      query: {
        'offerId': offerId
      },
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Get total count
   * Get the total number of offers on this marketplace contract.
   * @param chain Chain ID or name
   * @param contractAddress Contract Address on the Chain
   * @returns any Default Response
   * @throws ApiError
   */
  getTotalCount(chain, contractAddress) {
    return this.httpRequest.request({
      method: 'GET',
      url: '/marketplace/{chain}/{contractAddress}/offers/get-total-count',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Make offer
   * Make an offer on a token. A valid listing is not required.
   * @param chain Chain ID or name
   * @param contractAddress Contract Address on the Chain
   * @param xBackendWalletAddress Backend wallet address
   * @param requestBody
   * @param xAccountAddress Smart account address
   * @returns any Default Response
   * @throws ApiError
   */
  makeOffer(chain, contractAddress, xBackendWalletAddress, requestBody, xAccountAddress) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/marketplace/{chain}/{contractAddress}/offers/make-offer',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      headers: {
        'x-backend-wallet-address': xBackendWalletAddress,
        'x-account-address': xAccountAddress
      },
      body: requestBody,
      mediaType: 'application/json',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Cancel offer
   * Cancel a valid offer made by the caller wallet.
   * @param chain Chain ID or name
   * @param contractAddress Contract Address on the Chain
   * @param xBackendWalletAddress Backend wallet address
   * @param requestBody
   * @param xAccountAddress Smart account address
   * @returns any Default Response
   * @throws ApiError
   */
  cancelOffer(chain, contractAddress, xBackendWalletAddress, requestBody, xAccountAddress) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/marketplace/{chain}/{contractAddress}/offers/cancel-offer',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      headers: {
        'x-backend-wallet-address': xBackendWalletAddress,
        'x-account-address': xAccountAddress
      },
      body: requestBody,
      mediaType: 'application/json',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Accept offer
   * Accept a valid offer.
   * @param chain Chain ID or name
   * @param contractAddress Contract Address on the Chain
   * @param xBackendWalletAddress Backend wallet address
   * @param requestBody
   * @param xAccountAddress Smart account address
   * @returns any Default Response
   * @throws ApiError
   */
  acceptOffer(chain, contractAddress, xBackendWalletAddress, requestBody, xAccountAddress) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/marketplace/{chain}/{contractAddress}/offers/accept-offer',
      path: {
        'chain': chain,
        'contractAddress': contractAddress
      },
      headers: {
        'x-backend-wallet-address': xBackendWalletAddress,
        'x-account-address': xAccountAddress
      },
      body: requestBody,
      mediaType: 'application/json',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }
}

/* generated using openapi-typescript-codegen -- do no edit */
/* istanbul ignore file */
/* tslint:disable */
/* eslint-disable */

class PermissionsService {
  constructor(httpRequest) {
    this.httpRequest = httpRequest;
  }

  /**
   * Get all permissions
   * Get all users with their corresponding permissions
   * @returns any Default Response
   * @throws ApiError
   */
  getAll() {
    return this.httpRequest.request({
      method: 'GET',
      url: '/auth/permissions/get-all'
    });
  }

  /**
   * Grant permissions to user
   * Grant permissions to a user
   * @param requestBody
   * @returns any Default Response
   * @throws ApiError
   */
  grant(requestBody) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/auth/permissions/grant',
      body: requestBody,
      mediaType: 'application/json'
    });
  }

  /**
   * Revoke permissions from user
   * Revoke a user's permissions
   * @param requestBody
   * @returns any Default Response
   * @throws ApiError
   */
  revoke(requestBody) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/auth/permissions/revoke',
      body: requestBody,
      mediaType: 'application/json'
    });
  }
}

/* generated using openapi-typescript-codegen -- do no edit */
/* istanbul ignore file */
/* tslint:disable */
/* eslint-disable */

class TransactionService {
  constructor(httpRequest) {
    this.httpRequest = httpRequest;
  }

  /**
   * Get transaction status
   * Get the status for a transaction request.
   * @param queueId Transaction queue ID
   * @returns any Default Response
   * @throws ApiError
   */
  status(queueId) {
    return this.httpRequest.request({
      method: 'GET',
      url: '/transaction/status/{queueId}',
      path: {
        'queueId': queueId
      },
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Get all transactions
   * Get all transaction requests.
   * @param page This parameter allows the user to specify the page number for pagination purposes
   * @param limit This parameter defines the maximum number of transaction request data to return per page.
   * @returns any Default Response
   * @throws ApiError
   */
  getAll(page = '1', limit = '10') {
    return this.httpRequest.request({
      method: 'GET',
      url: '/transaction/get-all',
      query: {
        'page': page,
        'limit': limit
      },
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Get all deployment transactions
   * Get all transaction requests to deploy contracts.
   * @param page This parameter allows the user to specify the page number for pagination purposes
   * @param limit This parameter defines the maximum number of transaction request data to return per page.
   * @returns any Default Response
   * @throws ApiError
   */
  getAllDeployedContracts(page = '1', limit = '10') {
    return this.httpRequest.request({
      method: 'GET',
      url: '/transaction/get-all-deployed-contracts',
      query: {
        'page': page,
        'limit': limit
      },
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Retry transaction
   * Retry a transaction with updated gas settings.
   * @param requestBody
   * @returns any Default Response
   * @throws ApiError
   */
  retry(requestBody) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/transaction/retry',
      body: requestBody,
      mediaType: 'application/json',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Cancel transaction
   * Attempt to cancel a transaction by sending a null transaction with a higher gas setting. This transaction is not guaranteed to be cancelled.
   * @param requestBody
   * @returns any Default Response
   * @throws ApiError
   */
  cancel(requestBody) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/transaction/cancel',
      body: requestBody,
      mediaType: 'application/json',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }
}

/* generated using openapi-typescript-codegen -- do no edit */
/* istanbul ignore file */
/* tslint:disable */
/* eslint-disable */

class WebhooksService {
  constructor(httpRequest) {
    this.httpRequest = httpRequest;
  }

  /**
   * Get all webhooks configured
   * Get all webhooks configuration data set up on Engine
   * @returns any Default Response
   * @throws ApiError
   */
  getAll() {
    return this.httpRequest.request({
      method: 'GET',
      url: '/webhooks/get-all',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Create a new webhook
   * Create a new webhook
   * @param requestBody
   * @returns any Default Response
   * @throws ApiError
   */
  create(requestBody) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/webhooks/create',
      body: requestBody,
      mediaType: 'application/json',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Revoke webhook
   * Revoke a Webhook
   * @param requestBody
   * @returns any Default Response
   * @throws ApiError
   */
  revoke(requestBody) {
    return this.httpRequest.request({
      method: 'POST',
      url: '/webhooks/revoke',
      body: requestBody,
      mediaType: 'application/json',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }

  /**
   * Get webhooks event types
   * Get the all the webhooks event types
   * @returns any Default Response
   * @throws ApiError
   */
  getEventTypes() {
    return this.httpRequest.request({
      method: 'GET',
      url: '/webhooks/event-types',
      errors: {
        400: `Bad Request`,
        404: `Not Found`,
        500: `Internal Server Error`
      }
    });
  }
}

/* generated using openapi-typescript-codegen -- do no edit */
class EngineLogic {
  constructor(config, HttpRequest = FetchHttpRequest) {
    this.request = new HttpRequest({
      BASE: config?.BASE ?? '',
      VERSION: config?.VERSION ?? '0.0.2',
      WITH_CREDENTIALS: config?.WITH_CREDENTIALS ?? false,
      CREDENTIALS: config?.CREDENTIALS ?? 'include',
      TOKEN: config?.TOKEN,
      USERNAME: config?.USERNAME,
      PASSWORD: config?.PASSWORD,
      HEADERS: config?.HEADERS,
      ENCODE_PATH: config?.ENCODE_PATH
    });
    this.accessTokens = new AccessTokensService(this.request);
    this.account = new AccountService(this.request);
    this.accountFactory = new AccountFactoryService(this.request);
    this.backendWallet = new BackendWalletService(this.request);
    this.chain = new ChainService(this.request);
    this.configuration = new ConfigurationService(this.request);
    this.contract = new ContractService(this.request);
    this.contractEvents = new ContractEventsService(this.request);
    this.contractMetadata = new ContractMetadataService(this.request);
    this.contractRoles = new ContractRolesService(this.request);
    this.contractRoyalties = new ContractRoyaltiesService(this.request);
    this.default = new DefaultService(this.request);
    this.deploy = new DeployService(this.request);
    this.erc1155 = new Erc1155Service(this.request);
    this.erc20 = new Erc20Service(this.request);
    this.erc721 = new Erc721Service(this.request);
    this.marketplaceDirectListings = new MarketplaceDirectListingsService(this.request);
    this.marketplaceEnglishAuctions = new MarketplaceEnglishAuctionsService(this.request);
    this.marketplaceOffers = new MarketplaceOffersService(this.request);
    this.permissions = new PermissionsService(this.request);
    this.transaction = new TransactionService(this.request);
    this.webhooks = new WebhooksService(this.request);
  }
}
class Engine extends EngineLogic {
  constructor(config) {
    super({
      BASE: config.url,
      TOKEN: config.accessToken
    });
  }
}

/* generated using openapi-typescript-codegen -- do no edit */
/* istanbul ignore file */
/* tslint:disable */
/* eslint-disable */

const OpenAPI = {
  BASE: '',
  VERSION: '0.0.2',
  WITH_CREDENTIALS: false,
  CREDENTIALS: 'include',
  TOKEN: undefined,
  USERNAME: undefined,
  PASSWORD: undefined,
  HEADERS: undefined,
  ENCODE_PATH: undefined
};

exports.AccessTokensService = AccessTokensService;
exports.AccountFactoryService = AccountFactoryService;
exports.AccountService = AccountService;
exports.ApiError = ApiError;
exports.BackendWalletService = BackendWalletService;
exports.BaseHttpRequest = BaseHttpRequest;
exports.CancelError = CancelError;
exports.CancelablePromise = CancelablePromise;
exports.ChainService = ChainService;
exports.ConfigurationService = ConfigurationService;
exports.ContractEventsService = ContractEventsService;
exports.ContractMetadataService = ContractMetadataService;
exports.ContractRolesService = ContractRolesService;
exports.ContractRoyaltiesService = ContractRoyaltiesService;
exports.ContractService = ContractService;
exports.DefaultService = DefaultService;
exports.DeployService = DeployService;
exports.Engine = Engine;
exports.Erc1155Service = Erc1155Service;
exports.Erc20Service = Erc20Service;
exports.Erc721Service = Erc721Service;
exports.MarketplaceDirectListingsService = MarketplaceDirectListingsService;
exports.MarketplaceEnglishAuctionsService = MarketplaceEnglishAuctionsService;
exports.MarketplaceOffersService = MarketplaceOffersService;
exports.OpenAPI = OpenAPI;
exports.PermissionsService = PermissionsService;
exports.TransactionService = TransactionService;
exports.WebhooksService = WebhooksService;
